
REM this creates a zip file for each release platform (exe) and one for the source (all files).
REM previously 'build_release_files_exclude.txt' was set to exclude files from the xcopy cmd,
REM  but there needed to be too many hacks to get all files copied, also there was an uncertainty
REM  if files would be copied or not after adding new files, so now all files are specified here
REM  instead. This means that when new files/dirs are added to the project, lines may need to be
REM  added here.
REM a directory containing all files and the resulting zip files will be created in /release_packages.

REM the executable flag will now be set in the packages with a utility i've made to make files valid
REM  directly after extracting on linux and mac


REM ---------------------------------------------------------------------------
REM path setup

REM normally the 3 lines below is the only things that need editing
SET sevenzip="c:\Program Files\7-Zip\7z.exe"
SET innosetup="c:\Program Files (x86)\Inno Setup 5\ISCC.exe"
SET ver=1.86

SET dest_path=..\..\release_packages
SET path_source=%dest_path%\galaxyv2_%ver%_src
SET path_windows_bin=%dest_path%\galaxyv2_%ver%_windows_bin
SET path_linux_bin=%dest_path%\galaxyv2_%ver%_linux_bin
SET path_mac_bin=%dest_path%\galaxyv2_%ver%_mac_bin

pushd "%~dp0"

md "%dest_path%"
md "%path_source%"
md "%path_windows_bin%"
md "%path_linux_bin%"
md "%path_mac_bin%"


REM ---------------------------------------------------------------------------
REM source

REM /
xcopy ..\..\readme.txt "%path_source%\"
xcopy ..\..\todo.txt "%path_source%\"
xcopy ..\..\filetree.txt "%path_source%\"
xcopy ..\..\svn.txt "%path_source%\"
REM /src
md "%path_source%\src"
md "%path_source%\src\common"
md "%path_source%\src\editor"
md "%path_source%\src\galaxyv2"
md "%path_source%\src\graph"
md "%path_source%\src\server"
xcopy ..\..\src\common\*.cpp   "%path_source%\src\common\"
xcopy ..\..\src\common\*.h     "%path_source%\src\common\"
xcopy ..\..\src\editor\*.cpp   "%path_source%\src\editor\"
xcopy ..\..\src\editor\*.h     "%path_source%\src\editor\"
xcopy ..\..\src\galaxyv2\*.cpp "%path_source%\src\galaxyv2\"
xcopy ..\..\src\galaxyv2\*.h   "%path_source%\src\galaxyv2\"
xcopy ..\..\src\graph\*.cpp    "%path_source%\src\graph\"
xcopy ..\..\src\graph\*.h      "%path_source%\src\graph\"
xcopy ..\..\src\server\*.cpp   "%path_source%\src\server\"
xcopy ..\..\src\server\*.h     "%path_source%\src\server\"
REM /ext_include
md "%path_source%\ext_include"
md "%path_source%\ext_include\linux"
md "%path_source%\ext_include\mac"
md "%path_source%\ext_include\windows"
xcopy ..\..\ext_include\linux\*.h   "%path_source%\ext_include\linux\"
xcopy ..\..\ext_include\linux\*.c   "%path_source%\ext_include\linux\"
xcopy ..\..\ext_include\mac\*.h     "%path_source%\ext_include\mac\"
xcopy ..\..\ext_include\mac\*.cpp   "%path_source%\ext_include\mac\"
xcopy ..\..\ext_include\mac\*.m     "%path_source%\ext_include\mac\"
xcopy ..\..\ext_include\windows\*.h "%path_source%\ext_include\windows\"
REM /lib
md "%path_source%\lib"
md "%path_source%\lib\linux_x64"
md "%path_source%\lib\mac"
md "%path_source%\lib\win_x64"
md "%path_source%\lib\win_x86"
xcopy ..\..\lib\linux_x64\*.so "%path_source%\lib\linux_x64\"
xcopy ..\..\lib\mac\*.dylib "%path_source%\lib\mac\"
xcopy ..\..\lib\win_x64\*.lib "%path_source%\lib\win_x64\"
xcopy ..\..\lib\win_x64\*.dll "%path_source%\lib\win_x64\"
xcopy ..\..\lib\win_x86\*.lib "%path_source%\lib\win_x86\"
xcopy ..\..\lib\win_x86\*.dll "%path_source%\lib\win_x86\"
REM /exe
md "%path_source%\exe"
md "%path_source%\exe\data"
md "%path_source%\exe\data\editor_maps"
md "%path_source%\exe\data\external_maps"
md "%path_source%\exe\linux_x64"
md "%path_source%\exe\mac"
md "%path_source%\exe\mac\GalaxyV2.app"
md "%path_source%\exe\mac\MapEditor.app"
md "%path_source%\exe\mac\GalaxyV2.app\Contents"
md "%path_source%\exe\mac\MapEditor.app\Contents"
md "%path_source%\exe\mac\GalaxyV2.app\Contents\MacOS"
md "%path_source%\exe\mac\MapEditor.app\Contents\MacOS"
md "%path_source%\exe\mac\GalaxyV2.app\Contents\Resources"
md "%path_source%\exe\mac\MapEditor.app\Contents\Resources"
md "%path_source%\exe\windows"
xcopy ..\..\exe\data\* "%path_source%\exe\data\"
xcopy ..\..\exe\data\editor_maps\*.des "%path_source%\exe\data\editor_maps\"
xcopy ..\..\exe\data\editor_maps\*.map "%path_source%\exe\data\editor_maps\"
xcopy ..\..\exe\data\external_maps\*.des "%path_source%\exe\data\external_maps\"
xcopy ..\..\exe\data\external_maps\*.map "%path_source%\exe\data\external_maps\"
xcopy ..\..\exe\data\external_maps\*.tga "%path_source%\exe\data\external_maps\"
xcopy ..\..\exe\linux_x64\* "%path_source%\exe\linux_x64\"
xcopy ..\..\exe\mac\* "%path_source%\exe\mac\"
xcopy ..\..\exe\mac\GalaxyV2.app\Contents\* "%path_source%\exe\mac\GalaxyV2.app\Contents"
xcopy ..\..\exe\mac\MapEditor.app\Contents\* "%path_source%\exe\mac\MapEditor.app\Contents"
xcopy ..\..\exe\mac\GalaxyV2.app\Contents\MacOS\* "%path_source%\exe\mac\GalaxyV2.app\Contents\MacOS"
xcopy ..\..\exe\mac\MapEditor.app\Contents\MacOS\* "%path_source%\exe\mac\MapEditor.app\Contents\MacOS"
xcopy ..\..\exe\mac\GalaxyV2.app\Contents\Resources\* "%path_source%\exe\mac\GalaxyV2.app\Contents\Resources"
xcopy ..\..\exe\mac\MapEditor.app\Contents\Resources\* "%path_source%\exe\mac\MapEditor.app\Contents\Resources"
xcopy ..\..\exe\windows\* "%path_source%\exe\windows\"
REM /other
md "%path_source%\other"
md "%path_source%\other\fnt_comp"
md "%path_source%\other\img_cut"
md "%path_source%\other\res_comp"
md "%path_source%\other\resource_files"
md "%path_source%\other\web"
md "%path_source%\other\web\images"
md "%path_source%\other\web_replay"
md "%path_source%\other\web_replay\.settings"
md "%path_source%\other\web_replay\bin"
md "%path_source%\other\web_replay\bin\files"
md "%path_source%\other\web_replay\src"
md "%path_source%\other\web_replay\src\GalaxyPK"
md "%path_source%\other\web_replay\src\LoaderPK"
md "%path_source%\other\web_replay\src\SoundPK"
md "%path_source%\other\web_replay2"
md "%path_source%\other\web_replay2\web"
md "%path_source%\other\web_replay2\web\files"
md "%path_source%\other\web_play"
md "%path_source%\other\web_play\web"
md "%path_source%\other\web_play\web\files"
md "%path_source%\other\zip_exec"
xcopy ..\..\other\*.zip "%path_source%\other\"
xcopy ..\..\other\fnt_comp\*.cpp "%path_source%\other\fnt_comp\"
xcopy ..\..\other\img_cut\*.cpp "%path_source%\other\img_cut\"
xcopy ..\..\other\img_cut\*.txt "%path_source%\other\img_cut\"
xcopy ..\..\other\res_comp\*.cpp "%path_source%\other\res_comp\"
xcopy ..\..\other\resource_files\* "%path_source%\other\resource_files\"
xcopy ..\..\other\web\*.php "%path_source%\other\web\"
xcopy ..\..\other\web\*.css "%path_source%\other\web\"
xcopy ..\..\other\web\*.jar "%path_source%\other\web\"
xcopy ..\..\other\web\*.xml "%path_source%\other\web\"
xcopy ..\..\other\web\*.txt "%path_source%\other\web\"
xcopy ..\..\other\web\*.sql "%path_source%\other\web\"
xcopy ..\..\other\web\*.js "%path_source%\other\web\"
xcopy ..\..\other\web\images\*.png "%path_source%\other\web\images\"
xcopy ..\..\other\web\images\*.jpg "%path_source%\other\web\images\"
xcopy ..\..\other\web\images\*.gif "%path_source%\other\web\images\"
xcopy ..\..\other\web_replay\readme.txt "%path_source%\other\web_replay\"
xcopy ..\..\other\web_replay\project_clean_copy.bat "%path_source%\other\web_replay\"
xcopy ..\..\other\web_replay\.classpath "%path_source%\other\web_replay\"
xcopy ..\..\other\web_replay\.project "%path_source%\other\web_replay\"
xcopy ..\..\other\web_replay\.settings\org.eclipse.jdt.core.prefs "%path_source%\other\web_replay\.settings\"
xcopy ..\..\other\web_replay\bin\*.bat "%path_source%\other\web_replay\bin\"
xcopy ..\..\other\web_replay\bin\*.MF "%path_source%\other\web_replay\bin\"
xcopy ..\..\other\web_replay\bin\*.html "%path_source%\other\web_replay\bin\"
xcopy ..\..\other\web_replay\bin\files\* "%path_source%\other\web_replay\bin\files\"
xcopy ..\..\other\web_replay\src\*.java "%path_source%\other\web_replay\src\"
xcopy ..\..\other\web_replay\src\GalaxyPK\*.java "%path_source%\other\web_replay\src\GalaxyPK\"
xcopy ..\..\other\web_replay\src\LoaderPK\*.java "%path_source%\other\web_replay\src\LoaderPK\"
xcopy ..\..\other\web_replay\src\SoundPK\*.java "%path_source%\other\web_replay\src\SoundPK\"
xcopy ..\..\other\web_replay2\readme.txt "%path_source%\other\web_replay2\"
xcopy ..\..\other\web_replay2\*.bat "%path_source%\other\web_replay2\"
xcopy ..\..\other\web_replay2\.project "%path_source%\other\web_replay2\"
xcopy ..\..\other\web_replay2\pubspec.* "%path_source%\other\web_replay2\"
xcopy ..\..\other\web_replay2\web\* "%path_source%\other\web_replay2\web\"
xcopy ..\..\other\web_replay2\web\files\* "%path_source%\other\web_replay2\web\files\"
xcopy ..\..\other\web_play\readme.txt "%path_source%\other\web_play\"
xcopy ..\..\other\web_play\*.bat "%path_source%\other\web_play\"
xcopy ..\..\other\web_play\.project "%path_source%\other\web_play\"
xcopy ..\..\other\web_play\pubspec.* "%path_source%\other\web_play\"
xcopy ..\..\other\web_play\web\* "%path_source%\other\web_play\web\"
xcopy ..\..\other\web_play\web\files\* "%path_source%\other\web_play\web\files\"
xcopy ..\..\other\zip_exec\*.cpp "%path_source%\other\zip_exec\"
xcopy ..\..\other\zip_exec\*.txt "%path_source%\other\zip_exec\"
REM /build
md "%path_source%\build"
md "%path_source%\build\linux"
md "%path_source%\build\mac"
md "%path_source%\build\mac\GalaxyV2"
md "%path_source%\build\mac\GalaxyV2\GalaxyV2"
md "%path_source%\build\mac\GalaxyV2\GalaxyV2\en.lproj"
md "%path_source%\build\mac\GalaxyV2\GalaxyV2.xcodeproj"
md "%path_source%\build\mac\GalaxyV2.xcworkspace"
md "%path_source%\build\mac\MapEditor"
md "%path_source%\build\mac\MapEditor\MapEditor"
md "%path_source%\build\mac\MapEditor\MapEditor\en.lproj"
md "%path_source%\build\mac\MapEditor\MapEditor.xcodeproj"
md "%path_source%\build\mac\Server"
md "%path_source%\build\mac\Server\Server"
md "%path_source%\build\mac\Server\Server.xcodeproj"
md "%path_source%\build\windows"
xcopy ..\..\build\linux\Makefile "%path_source%\build\linux\"
xcopy ..\..\build\linux\virtualbox.txt "%path_source%\build\linux\"
xcopy ..\..\build\mac\*.icns "%path_source%\build\mac\"
xcopy ..\..\build\mac\GalaxyV2\GalaxyV2\GalaxyV2-Info.plist "%path_source%\build\mac\GalaxyV2\GalaxyV2\"
xcopy ..\..\build\mac\GalaxyV2\GalaxyV2.xcodeproj\project.pbxproj "%path_source%\build\mac\GalaxyV2\GalaxyV2.xcodeproj\"
xcopy ..\..\build\mac\GalaxyV2.xcworkspace\contents.xcworkspacedata "%path_source%\build\mac\GalaxyV2.xcworkspace\"
xcopy ..\..\build\mac\MapEditor\MapEditor\MapEditor-Info.plist "%path_source%\build\mac\MapEditor\MapEditor\"
xcopy ..\..\build\mac\MapEditor\MapEditor.xcodeproj\project.pbxproj "%path_source%\build\mac\MapEditor\MapEditor.xcodeproj\"
xcopy ..\..\build\mac\Server\Server.xcodeproj\project.pbxproj "%path_source%\build\mac\Server\Server.xcodeproj\"
xcopy ..\..\build\windows\*.bat "%path_source%\build\windows\"
xcopy ..\..\build\windows\*.rc "%path_source%\build\windows\"
xcopy ..\..\build\windows\*.ico "%path_source%\build\windows\"
xcopy ..\..\build\windows\*.sln "%path_source%\build\windows\"
xcopy ..\..\build\windows\*.iss "%path_source%\build\windows\"
xcopy ..\..\build\windows\zip_exec.exe "%path_source%\build\windows\"
xcopy ..\..\build\windows\fnt_comp.vcxproj "%path_source%\build\windows\"
xcopy ..\..\build\windows\fnt_comp.vcxproj.filters "%path_source%\build\windows\"
xcopy ..\..\build\windows\GalaxyV2.vcxproj "%path_source%\build\windows\"
xcopy ..\..\build\windows\GalaxyV2.vcxproj.user "%path_source%\build\windows\"
xcopy ..\..\build\windows\GalaxyV2.vcxproj.filters "%path_source%\build\windows\"
xcopy ..\..\build\windows\GraphWrapper.vcxproj "%path_source%\build\windows\"
xcopy ..\..\build\windows\GraphWrapper.vcxproj.filters "%path_source%\build\windows\"
xcopy ..\..\build\windows\img_cut.vcxproj "%path_source%\build\windows\"
xcopy ..\..\build\windows\img_cut.vcxproj.filters "%path_source%\build\windows\"
xcopy ..\..\build\windows\MapEditor.vcxproj "%path_source%\build\windows\"
xcopy ..\..\build\windows\MapEditor.vcxproj.filters "%path_source%\build\windows\"
xcopy ..\..\build\windows\MapEditor.vcxproj.user "%path_source%\build\windows\"
xcopy ..\..\build\windows\res_comp.vcxproj "%path_source%\build\windows\"
xcopy ..\..\build\windows\res_comp.vcxproj.filters "%path_source%\build\windows\"
xcopy ..\..\build\windows\Server.vcxproj "%path_source%\build\windows\"
xcopy ..\..\build\windows\Server.vcxproj.filters "%path_source%\build\windows\"
xcopy ..\..\build\windows\zip_exec.vcxproj "%path_source%\build\windows\"
xcopy ..\..\build\windows\VC_redist.x64.exe "%path_source%\build\windows\"
xcopy ..\..\build\windows\VC_redist.x86.exe "%path_source%\build\windows\"

%sevenzip% a -r -mx=9 -mtc=off "%dest_path%\galaxyv2_%ver%_src.zip" "%path_source%\"

zip_exec.exe "%dest_path%\galaxyv2_%ver%_src.zip" "galaxyv2_%ver%_src/exe/linux_x64/galaxyv2"
zip_exec.exe "%dest_path%\galaxyv2_%ver%_src.zip" "galaxyv2_%ver%_src/exe/linux_x64/mapeditor"
zip_exec.exe "%dest_path%\galaxyv2_%ver%_src.zip" "galaxyv2_%ver%_src/exe/linux_x64/server"
zip_exec.exe "%dest_path%\galaxyv2_%ver%_src.zip" "galaxyv2_%ver%_src/exe/mac/Server"
zip_exec.exe "%dest_path%\galaxyv2_%ver%_src.zip" "galaxyv2_%ver%_src/exe/mac/GalaxyV2.app/Contents/MacOS/GalaxyV2"
zip_exec.exe "%dest_path%\galaxyv2_%ver%_src.zip" "galaxyv2_%ver%_src/exe/mac/MapEditor.app/Contents/MacOS/MapEditor"


REM ---------------------------------------------------------------------------
REM linux bin (x64)

md "%path_linux_bin%\editor_maps"
md "%path_linux_bin%\external_maps"
md "%path_linux_bin%\data"
md "%path_linux_bin%\x64"
xcopy ..\..\exe\linux_x64\* "%path_linux_bin%\x64\"
xcopy ..\..\exe\data\* "%path_linux_bin%\data\"
xcopy ..\..\exe\data\editor_maps\*.des "%path_linux_bin%\editor_maps\"
xcopy ..\..\exe\data\editor_maps\*.map "%path_linux_bin%\editor_maps\"
xcopy ..\..\exe\data\external_maps\*.des "%path_linux_bin%\external_maps\"
xcopy ..\..\exe\data\external_maps\*.map "%path_linux_bin%\external_maps\"
xcopy ..\..\exe\data\external_maps\*.tga "%path_linux_bin%\external_maps\"

%sevenzip% a -r -mx=9 -mtc=off "%dest_path%\galaxyv2_%ver%_linux_bin.zip" "%path_linux_bin%\"

zip_exec.exe "%dest_path%\galaxyv2_%ver%_linux_bin.zip" "galaxyv2_%ver%_linux_bin/x64/galaxyv2"
zip_exec.exe "%dest_path%\galaxyv2_%ver%_linux_bin.zip" "galaxyv2_%ver%_linux_bin/x64/mapeditor"
zip_exec.exe "%dest_path%\galaxyv2_%ver%_linux_bin.zip" "galaxyv2_%ver%_linux_bin/x64/server"


REM ---------------------------------------------------------------------------
REM mac bin

md "%path_mac_bin%\editor_maps"
md "%path_mac_bin%\external_maps"
md "%path_mac_bin%\GalaxyV2.app"
md "%path_mac_bin%\MapEditor.app"
md "%path_mac_bin%\GalaxyV2.app\Contents"
md "%path_mac_bin%\MapEditor.app\Contents"

md "%path_mac_bin%\GalaxyV2.app\Contents\MacOS"
md "%path_mac_bin%\MapEditor.app\Contents\MacOS"
md "%path_mac_bin%\GalaxyV2.app\Contents\Resources"
md "%path_mac_bin%\MapEditor.app\Contents\Resources"
xcopy ..\..\exe\mac\* "%path_mac_bin%\"
xcopy ..\..\exe\mac\GalaxyV2.app\Contents\* "%path_mac_bin%\GalaxyV2.app\Contents\"
xcopy ..\..\exe\mac\MapEditor.app\Contents\* "%path_mac_bin%\MapEditor.app\Contents\"
xcopy ..\..\exe\mac\GalaxyV2.app\Contents\MacOS\* "%path_mac_bin%\GalaxyV2.app\Contents\MacOS\"
xcopy ..\..\exe\mac\MapEditor.app\Contents\MacOS\* "%path_mac_bin%\MapEditor.app\Contents\MacOS\"
xcopy ..\..\exe\mac\GalaxyV2.app\Contents\Resources\*.icns "%path_mac_bin%\GalaxyV2.app\Contents\Resources\"
xcopy ..\..\exe\mac\MapEditor.app\Contents\Resources\*.icns "%path_mac_bin%\MapEditor.app\Contents\Resources\"
xcopy ..\..\exe\data\* "%path_mac_bin%\"
xcopy ..\..\exe\data\editor_maps\*.des "%path_mac_bin%\editor_maps\"
xcopy ..\..\exe\data\editor_maps\*.map "%path_mac_bin%\editor_maps\"
xcopy ..\..\exe\data\external_maps\*.des "%path_mac_bin%\external_maps\"
xcopy ..\..\exe\data\external_maps\*.map "%path_mac_bin%\external_maps\"
xcopy ..\..\exe\data\external_maps\*.tga "%path_mac_bin%\external_maps\"

%sevenzip% a -r -mx=9 -mtc=off "%dest_path%\galaxyv2_%ver%_mac_bin.zip" "%path_mac_bin%\"

zip_exec.exe "%dest_path%\galaxyv2_%ver%_mac_bin.zip" "galaxyv2_%ver%_mac_bin/Server"
zip_exec.exe "%dest_path%\galaxyv2_%ver%_mac_bin.zip" "galaxyv2_%ver%_mac_bin/GalaxyV2.app/Contents/MacOS/GalaxyV2"
zip_exec.exe "%dest_path%\galaxyv2_%ver%_mac_bin.zip" "galaxyv2_%ver%_mac_bin/MapEditor.app/Contents/MacOS/MapEditor"

REM ---------------------------------------------------------------------------
REM windows bin

md "%path_windows_bin%\editor_maps"
md "%path_windows_bin%\external_maps"
xcopy ..\..\exe\windows\* "%path_windows_bin%\"
xcopy ..\..\exe\data\* "%path_windows_bin%\"
xcopy ..\..\exe\data\editor_maps\*.des "%path_windows_bin%\editor_maps\"
xcopy ..\..\exe\data\editor_maps\*.map "%path_windows_bin%\editor_maps\"
xcopy ..\..\exe\data\external_maps\*.des "%path_windows_bin%\external_maps\"
xcopy ..\..\exe\data\external_maps\*.map "%path_windows_bin%\external_maps\"
xcopy ..\..\exe\data\external_maps\*.tga "%path_windows_bin%\external_maps\"

%sevenzip% a -r -mx=9 -mtc=off "%dest_path%\galaxyv2_%ver%_windows_bin.zip" "%path_windows_bin%\"

REM ---------------------------------------------------------------------------
REM creates a windows installer with InnoSetup (cmdline)
REM the iss file should be up to date by using InnoSetup (gui)

%innosetup% "galaxyv2.iss"

REM ---------------------------------------------------------------------------
popd
