#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <OpenGL/gl.h>

extern "C" void FsOpenWindowC(int x0, int y0, int w, int h, bool useDoubleBuffer, bool resize);
extern "C" void FsSetWindowTitleC(char *szTitle);
extern "C" void FsGetWindowSizeC(int *w, int *h);
extern "C" int FsPollDeviceC();
extern "C" void FsSleepC(int ms);
extern "C" int FsPassedTimeC();
extern "C" void FsSetMouseExclusiveC(bool bExclusive);
extern "C" void FsMouseC(int *lb, int *mb, int *rb, int *mx, int *my);
extern "C" int FsGetMouseEventC(int *lb, int *mb, int *rb, int *mx, int *my, int *wheel);
extern "C" void FsSwapBufferC();
extern "C" int FsInkeyC();
extern "C" int FsInkeyCharC();
extern "C" int FsKeyStateC(int fsKeyCode);
extern "C" void FsChangeToProgramDirC();
extern "C" void FsCheckExposureC();
extern "C" bool FsFileOpenDialogC(char *szPath, int iLength, struct file_dialog_info *pFI);
extern "C" bool FsGetClipboardTextC(char *szText, int iLength);

void FsOpenWindow(int x0, int y0, int w, int h, bool useDoubleBuffer, bool resize)
{
	FsOpenWindowC(x0, y0, w, h, useDoubleBuffer, resize);
}

void FsSetMouseExclusive(bool bExclusive)
{
	FsSetMouseExclusiveC(bExclusive);
}

void FsSetWindowTitle(char *szTitle)
{
	FsSetWindowTitleC(szTitle);
}

void FsGetWindowSize(int &w, int &h)
{
	FsGetWindowSizeC(&w, &h);
}

int FsPollDevice()
{
	return FsPollDeviceC();
}

void FsSleep(int ms)
{
	FsSleepC(ms);
}

int FsPassedTime()
{
	return FsPassedTimeC();
}

void FsGetMouseState(int &lb, int &mb, int &rb, int &mx, int &my)
{
	FsMouseC(&lb, &mb, &rb, &mx, &my);
}

int FsGetMouseEvent(int &lb, int &mb, int &rb, int &mx, int &my, int &wheel)
{
	return FsGetMouseEventC(&lb, &mb, &rb, &mx, &my, &wheel);
}

void FsSwapBuffers()
{
	FsSwapBufferC();
}

int FsInkey()
{
	return FsInkeyC();
}

int FsInkeyChar()
{
	return FsInkeyCharC();
}

int FsGetKeyState(int fsKeyCode)
{
	return FsKeyStateC(fsKeyCode);
}

void FsCheckWindowExposure()
{
	return FsCheckExposureC();
}

void FsChangeToProgramDir()
{
	FsChangeToProgramDirC();
}

bool FsFileOpenDialog(char *szPath, int iLength, struct file_dialog_info *pFI)
{
	return FsFileOpenDialogC(szPath, iLength, pFI);
}

bool FsGetClipboardText(char *szText, int iLength)
{
	return FsGetClipboardTextC(szText, iLength);
}

//the following is to allow drawing during a live resize
// session, since the polling loop will stop
typedef void((*DRAWCALLBACKTYPE)(void));
DRAWCALLBACKTYPE g_pRedrawCallback = NULL;
void FsSetRedrawCallback(DRAWCALLBACKTYPE pCallback)
{
	g_pRedrawCallback = pCallback;
}

extern "C" void FsRedrawCallback()
{
	if(g_pRedrawCallback) g_pRedrawCallback();
}
