<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
	<meta http-equiv="content-language" content="en-us">
	<meta name="description" content="Galaxy Forces V2 - A multiplayer space shooter with global hiscores and achievements.">
	<meta name="keywords" content="game multiplayer AI 2D space shooter hiscore achievements">
	<meta name="author" content="RH">
	<meta name="viewport" content="initial-scale=1">

	<title>Galaxy Forces V2: Game</title>
	<link rel="stylesheet" type="text/css" href="gf.css">
	<link rel="icon" type="image/gif" href="images/favicon.gif">
	<script type="text/javascript" src="https://apis.google.com/js/plusone.js">{ parsetags: 'explicit' }</script>
</head>
<body>

<table class=main align="center" cellspacing="0" cellpadding="0">
<tr><td>

<br>
<?php
require_once("headline.php");
headline("Galaxy Forces V2");
?>
<br>

<?php
square_start("'100%'");
?>
<p>A single and multiplayer 2D space shooter game. Each player is in control of a ship.
The goal is to kill everything to get the best score (<i>dogfight</i>),
or race against the clock and your opponents to get the fastest time (<i>race</i>).
There is also a mode where the players compete to transport cargo (<i>mission</i>), and where they cooperate (<i>mission_coop</i>).</p>

<p>There are more than 50 official levels, and a map-editor is included so you can create your own. Also online <a href="#hiscore">Hiscores</a> are available.</p>

<p>The game is inspired by <a href="https://www.mobygames.com/game/amiga/gravity-force">Gravity Force</a> on the Amiga, and it could be considered a Gravity Force clone with more features.</p>

<p>Download Galaxy Forces V2 (<a href="http://downloads.sourceforge.net/galaxyv2/galaxyv2_1.85_setup.exe">Windows</a>, <a href="http://downloads.sourceforge.net/galaxyv2/galaxyv2_1.85_linux_bin.zip">Linux</a>, <a href="http://downloads.sourceforge.net/galaxyv2/galaxyv2_1.85_mac_bin.zip">Mac</a>, <a href="http://downloads.sourceforge.net/galaxyv2/galaxyv2_1.85_src.zip">Code</a>).
</p>
<p>It is optional, but suggested that you create a user <a href="member_register.php">here</a>.</p>

<table cellspacing="10" cellpadding="0">
<tr>
<td><a href="http://www.galaxy-forces.com/web_play.php?Level=race00_3pl&Name=You"><img align="left" src="images/b_now1.png" title="Play now" alt="Play now"></a></td>
<td><a href="http://sourceforge.net/projects/galaxyv2/files/galaxyv2/galaxyv2_1.85/"><img align="left" src="images/b_now2.png" title="Download now" alt="Download now"></a></td>
</tr>
<tr>
<td><iframe width="425" height="349" src="https://www.youtube.com/embed/1cE4mQd7GQ8?hl=sv&amp;fs=1" frameborder="0"></iframe></td>
<td><iframe width="425" height="349" src="https://www.youtube.com/embed/4OnD8rxeU-Q?hl=sv&amp;fs=1" frameborder="0"></iframe></td>
</tr>
<tr>
<td><iframe width="425" height="349" src="https://www.youtube.com/embed/N_BgZf-IQQE?hl=sv&amp;fs=1" frameborder="0"></iframe></td>
<td><iframe width="425" height="349" src="https://www.youtube.com/embed/ln7dX9pVUYk?hl=sv&amp;fs=1" frameborder="0"></iframe></td>
</tr>
</table>
<?php
square_end();
?>
<br><br><br>

<?php
headline("Open source");
?>
<br>
<?php
square_start("'100%'");
?>
<p>The game is quite fun, but it still misses some things.
It was put on sourceforge so that others may join and help make it better, the project is public domain.</p>
<p>There is an experimental AI player included in the game now and a new AI is being implemented.
Also some of the graphics and sounds needs to be improved and extended (more decoration tiles).</p>
<p><p>But anything anyone feels they want to contribute with is welcome.</p>
<p>The game, server and editor have recently been ported to Linux and Mac.</p>
<p>Here are some info about how certain elements in the game are <a href="implementation.php">implemented</a> (the AI for example).</p>
<table class=data><tr><td>
<a href="http://sourceforge.net/projects/galaxyv2/"><img align="left" src="images/icon48.png" title="Galaxy Forces V2 sourceforge project page" alt="Galaxy Forces V2 sourceforge project page"></a>
</td><td width='10px'></td><td>
<a href="http://sourceforge.net"><img src="http://sflogo.sourceforge.net/sflogo.php?group_id=176175&amp;type=4" title="sourceforge.net" alt="sourceforge.net Logo"></a>
</td></tr></table>
<?php
square_end();
?>
<br><br><br>

<a name="hiscore"></a>
<?php
headline("Hiscores");
?>
<br>

<?php
square_start("'100%'");
?>
<p>You can test playing a level right here on the web by clicking the level name, and you can view replay of hiscores by clicking the score.</p>
<table width="83%">
<tr><td>
<?php
require_once("print_hiscore2.php");
print_hiscore();
?>
</td></tr>
</table>
<?php
square_end();
?>
<br><br><br>


<?php
headline("Game instructions");
?>
<br>
<?php
square_start("'100%'");
?>

<h4>Start the program</h4>
<p>Multiple instances of the game may be started on the same machine for testing.<br>
The server (Server.exe) need only be run if you want a stand alone server.</p>

<h4>Firewall ports</h4>
<p>TCP port 1999 needs to be forwarded in your firewall/router to be able to host games and have other players join you.</p>

<h4>Login as member</h4>
<p>To use achievements and hiscores you need to create a user <a href="member_register.php">here</a>.<br>
Then login as that user, or select cancel to just play directly.</p>

<h4>Connect to server</h4>
<p>Enter the IP address or host name of a server and click "connect".<br>
You can enter 127.0.0.1 to connect to your own server.<br>
All games on that server will be shown.<br>
You can join green games.<br>
You can't join red games, they are full or already started.<br>
If no game is shown you have to create a new game.</p>

<h4>Join existing game</h4>
<p>Enter your name and choose a green game from the list.<br>
Click "Join".</p>

<h4>Create new game</h4>
<p>Enter your name, and the name of the game.<br>
Click "New".</p>

<h4>Start game</h4>
<p>The player that created the game should set the level to play and make other settings before starting the game. This player will be the master.<br>
Others that have joined can only chat until the game starts.</p>
<p>The master can kick players by selecting a player and press delete.<br>
If the master leaves the game, mastership is transferred to another player.</p>

<h4>View replay</h4>
<p>When connected but before a game is joined, click "Replays". Choose a replay in the list then click "Play".</p>

<h4>Steering</h4>
<table class=data width="80%">
<tr valign="top"><td><i>Keyboard</i></td><td><i>Pad default</i></td><td><i>Game effect</i></td></tr>
<tr valign="top"><td>Left Arrow/A</td><td>Left</td><td>Steer left</td></tr>
<tr valign="top"><td>Right Arrow/D</td><td>Right</td><td>Steer right</td></tr>
<tr valign="top"><td>Up Arrow/W</td><td>Button 1</td><td>Thrust</td></tr>
<tr valign="top"><td>Down Arrow/S</td><td>Down</td><td>Prepare ship for landing</td></tr>
<tr valign="top"><td>Return/Space</td><td>Button 2</td><td>Fire</td></tr>
<tr valign="top"><td>TAB</td><td></td><td>Type a chat message</td></tr>
<tr valign="top"><td height="10px"></td><td></td><td></td></tr>
<tr valign="top"><td>Esc</td><td></td><td>Exit/Back</td></tr>
<tr valign="top"><td>M</td><td></td><td>Music on/off</td></tr>
<tr valign="top"><td>N</td><td></td><td>Sound FX on/off</td></tr>
<tr valign="top"><td>I</td><td></td><td>Minimap on/off</td></tr>
<tr valign="top"><td>F</td><td></td><td>Show FPS on/off</td></tr>
<tr valign="top"><td>7</td><td></td><td>Restart a one player game</td></tr>
<tr valign="top"><td>V</td><td></td><td>Change player to follow in a replay</td></tr>
</table>

<h4>Rules</h4>
<p>Collect as much points as possible or get the fastest time on the racetracks.<br>
Your ship is fragile; it can only be hit by one bullet!<br>
Everyone is free from there own bullets.<br>
You will die if you hit anything that is not black, both parts of the map and enemies.<br>
You are able to land on the grey landing zones if you are careful and keep
the velocity, angle and position of your ship right.<br>
You don't crash with things on the landing zones.</p>

<h4>Mission specific</h4>
<p>You finish a mission level by transporting all cargo (small packages on landing zones) to
a home base (landing zone with a warehouse). If you die, any loaded cargo is re-spawned.<br>
You have fuel in your tank to use the thrusters for 60 seconds. If you run out of fuel,
you will probably die. You refuel automatically on home bases.<br>
In mission coop levels you cooperate to transport the cargo, and all players get the same combined score (but only the master get to send in a hiscore).</p>

<h4>Score</h4>
<table class=data width="70%">
<tr valign="top"><td width='42%'>Collision with the wall</td><td>-10</td></tr>
<tr valign="top"><td>Killed by computer enemy</td><td>-10</td></tr>
<tr valign="top"><td>Collision with opponent</td><td>0</td></tr>
<tr valign="top"><td>Shot by opponent</td><td>0</td></tr>
<tr valign="top"><td>You shot opponent</td><td>25 (only dogfight)</td></tr>
<tr valign="top"><td>You shot a computer enemy</td><td>Depends of enemy type</td></tr>
<tr valign="top"><td>Cargo delivered</td><td>Depends on the cargo weight, the ship can carry max 50 (or 3 units)</td></tr>
</table>
<p>Every life left when the level ends gives 50 points. The score is also based on the time taken until the level is complete... The time taken gives a minus to the score (seconds/2).</p>
<br>

<table class=data width="70%">
<tr><td><i>Enemy</i></td><td><i>Hits to kill</i></td><td><i>Score</i></td></tr>
<tr valign="top"><td width='35%'><img src="images/white_tower.png" title="White Tower" alt="White Tower"></td><td>4</td><td>10</td></tr>
<tr valign="top"><td><img src="images/black_tower.png" title="Black Tower" alt="Black Tower"></td><td>Immortal</td><td>-</td></tr>
<tr valign="top"><td><img src="images/blue_3_shooter.png" title="Blue 3-Shooter" alt="Blue 3-Shooter"></td><td>5</td><td>20</td></tr>
<tr valign="top"><td><img src="images/black_3_shooter.png" title="Black 3-Shooter" alt="Black 3-Shooter"></td><td>Immortal</td><td>-</td></tr>
<tr valign="top"><td><img src="images/white_5_shooter.png" title="White 5-shooter" alt="White 5-shooter"></td><td>4</td><td>25</td></tr>
<tr valign="top"><td><img src="images/green_guardian.png" title="Green Guardian" alt="Green Guardian"></td><td>4</td><td>15</td></tr>
<tr valign="top"><td><img src="images/blue_whirlwind.png" title="Blue Whirlwind" alt="Blue Whirlwind"></td><td>8</td><td>20</td></tr>
</table>

<?php
square_end();
?>

<br>

</td></tr>
</table>

<?php
	//update statistics
	require_once("db_connect.php");
	$db = connect_to_db();
	$query = "UPDATE statistics_t SET count=count+1 WHERE page='index.php'";
	$info = mysqli_query($db, $query);
	if($db) mysqli_close($db);
?>

</body>
</html>