
part of web_play;


class C_Collision
{
  static int _s_iDetectPixelStepX = 1; //increase to make it faster and check less pixels (minimum 1)
  static int _s_iDetectPixelStepY = 1; //increase to make it faster and check less pixels (minimum 1)

  static MutableRectangle _s_r1 = new MutableRectangle(0, 0, 0, 0);
  static MutableRectangle _s_r2 = new MutableRectangle(0, 0, 0, 0);
  static S_Rect _s_stR1 = new S_Rect(0,0,0,0), _s_stR2 = new S_Rect(0,0,0,0);

  static bool Compare(C_Image i_Img1, int i_iX1, int i_iY1, C_Image i_Img2, int i_iX2, int i_iY2, S_Rect i_stRect1, S_Rect i_stRect2)
  {
    int i, j;

    if(i_Img1==null && i_stRect1==null) return false;
    if(i_Img2==null && i_stRect2==null) return false;

    //get image info
    _s_r1.left = i_iX1; _s_r1.top = i_iY1;
    if(i_stRect1==null) {
      _s_r1.width = i_Img1.width;
      _s_r1.height = i_Img1.height;
    } else {
      _s_r1.width = i_stRect1.width;
      _s_r1.height = i_stRect1.height;
    }
    _s_r2.left = i_iX2; _s_r2.top = i_iY2;
    if(i_stRect2==null) {
      _s_r2.width = i_Img2.width;
      _s_r2.height = i_Img2.height;
    } else {
      _s_r2.width = i_stRect2.width;
      _s_r2.height = i_stRect2.height;
    }

    //r1, r2 filled now; make intersectrect
    Rectangle rtmp = _s_r1.intersection(_s_r2);
    if(rtmp==null) return false; //no collision
    if(i_Img1==null && i_Img2==null) return true;  //rectangle collision

    //calc stR1, stR2

    _s_stR1.Set(rtmp.left, rtmp.top, rtmp.width, rtmp.height);
    _s_stR2.Set(rtmp.left, rtmp.top, rtmp.width, rtmp.height);
    _s_stR1.x -= i_iX1; _s_stR1.y -= i_iY1;
    _s_stR2.x -= i_iX2; _s_stR2.y -= i_iY2;
    if(i_stRect1!=null) { _s_stR1.x += i_stRect1.x; _s_stR1.y += i_stRect1.y; }
    if(i_stRect2!=null) { _s_stR2.x += i_stRect2.x; _s_stR2.y += i_stRect2.y; }

    //check collission pixel for pixel
    int iW = _s_stR1.width; //same width, height
    int iH = _s_stR1.height;

    if(i_Img1!=null && i_Img2!=null) {
      for(j=0; j<iH; j+=_s_iDetectPixelStepY) { //y
        for(i=0; i<iW; i+=_s_iDetectPixelStepX) { //x
          bool pix1 = i_Img1.mask[j+_s_stR1.y][_s_stR1.x+i];
          bool pix2 = i_Img2.mask[j+_s_stR2.y][_s_stR2.x+i];
          if(!pix1 || !pix2) continue;
          return true; //both pixels were non black
        }
      }
    } else {
      if(i_Img1!=null) {
        for(j=0; j<iH; j+=_s_iDetectPixelStepY) { //y
          for(i=0; i<iW; i+=_s_iDetectPixelStepX) { //x
            bool pix1 = i_Img1.mask[j+_s_stR1.y][_s_stR1.x+i];
            if(!pix1) continue;
            return true;
          }
        }
      } else {
        for(j=0; j<iH; j+=_s_iDetectPixelStepY) { //y
          for(i=0; i<iW; i+=_s_iDetectPixelStepX) { //x
            bool pix2 = i_Img2.mask[j+_s_stR2.y][_s_stR2.x+i];
            if(!pix2) continue;
            return true;
          }
        }
      }
    }

    return false;
  }

}
