
part of web_play;


class C_LandingZone extends C_Object
{
  //image
  static C_Image s_oLandingZoneImg;
  static final S_Rect _s_oLandingRect = new S_Rect(0,44,96,4);
  static final S_Rect _s_oHouseRect = new S_Rect(70,23,24,21);
  static final List<S_Rect> _s_oAntennaRects = [new S_Rect(0,15,4,29),new S_Rect(4,15,4,29),new S_Rect(8,15,4,29),new S_Rect(12,15,4,29),new S_Rect(16,15,4,29)];
  static final List<S_Rect> _s_oCargoRects = [new S_Rect(54,38,14,6),new S_Rect(54,32,14,6),new S_Rect(54,26,14,6),new S_Rect(54,20,14,6)];
  static final S_Rect _s_oExtraLifeRect = new S_Rect(20,25,14,19);
  static void InitImage(C_Image i_oLandingZoneImg)
  {
    s_oLandingZoneImg = i_oLandingZoneImg;
  }

  //other
  C_TileMap _m_oMap;
  bool _m_bShowAntenna, _m_bShowHouse;
  double _m_dAntennaFrame;
  List<int> _m_aiCargo; //array of cargo weights (small = 1..5,6..10,11..15,16..20+ = huge)
  bool _m_bExtraLife;
  int _m_iZoneSize;

  S_Rect _tmpRect = new S_Rect(0,0,0,0);

  static int LAND_X1 = 9;  //when shipsize is 48*48...
  static int LAND_X2 = 39; //^
  static int LAND_Y  = 42; //^
  static final List<Point> LAND_BPOS = [new Point(13,44),new Point(10,42),new Point(34,44)];

  bool m_bPlayerIsLanded = false;
  double m_dTimeLanded = 0.0;

  C_LandingZone(C_TileMap i_oMap, int i_iZoneID, int i_iX, int i_iY, int i_iZoneSize, bool i_bShowAntenna, bool i_bShowHouse, List<int> i_aiCargo, bool i_bExtraLife)
   : super()
  {
    m_dPosX = i_iX.toDouble();
    m_dPosY = i_iY.toDouble();
    _m_dVelX = _m_dVelY = _m_dAcceleration = 0.0;
    _m_dDirection = 270.0;
    _m_iZoneSize = i_iZoneSize;
    m_iOwnerID = i_iZoneID;

    _m_oMap = i_oMap;
    _m_stScreenArea = _m_oMap.GetScreenRect();

    _m_oImage = s_oLandingZoneImg;
    _m_stImageRect = _s_oLandingRect;

    _m_bShowAntenna = i_bShowAntenna;
    _m_bShowHouse = i_bShowHouse;
    _m_aiCargo = i_aiCargo;
    _m_dAntennaFrame = 0.0;

    _m_bExtraLife = i_bExtraLife;

    m_bPlayerIsLanded = false;
  }

  void UpdateFuel(C_Player i_oPlayer, double i_dTime)
  {
    //refuel if homebase
    if(!_m_bShowHouse) return;
    _tmpRect.Set(m_dPosX.toInt(), m_dPosY.toInt(), 32*_m_iZoneSize, _s_oLandingRect.height+20);
    double x = i_oPlayer.m_dPosX+LAND_BPOS[1].x;
    double y = i_oPlayer.m_dPosY+LAND_BPOS[1].y;
    bool bPointInRect = (((x) >= _tmpRect.x) && ((x) <= _tmpRect.x+_tmpRect.width) && ((y) >= _tmpRect.y) && ((y) <= _tmpRect.y+_tmpRect.height));
    if( i_oPlayer._m_iRealDir==27 && bPointInRect)
    {
      i_oPlayer.AddFuel((i_dTime*0.01)*1.0); //refuel 10 times faster than fuelburn
    }
  }

  bool POINTINRECT(xx, yy, rect) {
    return (((xx) >= (rect).x) && ((xx) <= (rect).x+(rect).width) && ((yy) >= (rect).y) && ((yy) <= (rect).y+(rect).height));
  }

  void UpdateLanding(C_Player i_pclPlayer, double i_dTime)
  {
    _m_dAntennaFrame += i_dTime*0.0046; //4.6 fps anim
    if(_m_dAntennaFrame>=_s_oAntennaRects.length) _m_dAntennaFrame = 0.0; //is m_dAntennaFrame-='length' really, but then it can happen that it'll be more than 'length' when too much time have passed since last time (frame)...

    if(i_pclPlayer==null) return;
    int iPlayerId = i_pclPlayer.m_iOwnerID;
    if(!i_pclPlayer.IsAlive()) {
      m_bPlayerIsLanded = false;
      return;
    }

    int iDir = i_pclPlayer._m_iRealDir - 26;
    S_Rect stRect = new S_Rect(m_dPosX.toInt(), m_dPosY.toInt(), 32*_m_iZoneSize, _s_oLandingRect.height+20);
    //^check against rectangle that is thicker than the landingzone to detect a landing even if the ship is a little below the bottom of the zone.

    if((i_pclPlayer._m_iRealDir<=28) && (i_pclPlayer._m_iRealDir>=26)
      && POINTINRECT(i_pclPlayer.m_dPosX+LAND_BPOS[iDir].x, i_pclPlayer.m_dPosY+LAND_BPOS[iDir].y, stRect))
    {
      //^ok with only rectangle collission detection for this object (no OCheckCollision)

      if(!m_bPlayerIsLanded) {
        //land, bounce or crashland?
        if((i_pclPlayer.m_dPosX+LAND_X1>m_dPosX) && (i_pclPlayer.m_dPosX+LAND_X2<m_dPosX+32*_m_iZoneSize)) {
          if((i_pclPlayer._m_dVelX.toInt().abs()<32) && (i_pclPlayer._m_dVelY.toInt()>=0) && (i_pclPlayer._m_dVelY<40)) { //land
            i_pclPlayer.LandOnZone(m_dPosY-LAND_Y);
            m_bPlayerIsLanded = true;
            m_dTimeLanded = 0.0;
          } else if((i_pclPlayer._m_dVelX.toInt().abs()<72) && i_pclPlayer._m_dVelY>=0 && i_pclPlayer._m_dVelY<102) { //bounce
            i_pclPlayer.BounceOnZone(m_dPosY-LAND_Y);
          } else i_pclPlayer.Kill(/*KILLEDBY_SELF, 0*/); //to high velocity, ship explodes
        } else i_pclPlayer.Kill(/*KILLEDBY_SELF, 0*/); //outside landingzone, ship explodes
      }
    } else {
      m_bPlayerIsLanded = false;
    }

    if(m_bPlayerIsLanded) {
      //do action depending on type of LZ and depending on
      //current cargo on ship, all depending on m_dTimeLanded
      m_dTimeLanded += i_dTime;

      //first: can only do actions so fast
      if(m_dTimeLanded>800) {
        m_dTimeLanded = 0.0;

        //first take any extra life
        if(_m_bExtraLife) {
          TakeExtraLife();
          i_pclPlayer.AddLife();
        } else { //then act on cargo
          if(!_m_bShowHouse) { //pick up cargo
            if(_m_aiCargo!=null && _m_aiCargo.length>0) { //there are cargo left on zone
              int iPos = _m_aiCargo.length-1;
              if(i_pclPlayer.SpaceInHold(_m_aiCargo[iPos])) { //player has space in hold
                int iCargo = PopCargo();
                i_pclPlayer.LoadCargo(iCargo, this.m_iOwnerID);
              }
            }
          } else { //unload cargo
            i_pclPlayer.UnloadCargo();
          }
        }
      } //else no action this time

      //refuel if homebase
      if(_m_bShowHouse) i_pclPlayer.AddFuel((i_dTime*0.01)*1.0); //refuel 10 times faster than fuelburn
    }
  }

  void Draw()
  {
    int px = _m_oMap.GetPosX();
    int py = _m_oMap.GetPosY();
    _m_stScreenArea = _m_oMap.GetScreenRect();

    _tmpRect.Set(_m_stImageRect.x, _m_stImageRect.y, _m_stImageRect.width, _m_stImageRect.height);
    _tmpRect.width = 32;
    ODraw(_m_oImage, _tmpRect, px, py); //left part
    _tmpRect.x += 32;
    for(int i=0; i<_m_iZoneSize-2; i++) {
      ODraw(_m_oImage, _tmpRect, px-32-i*32, py); //centre parts
    }
    _tmpRect.x += 32;
    ODraw(_m_oImage, _tmpRect, px-(_m_iZoneSize-1)*32, py); //right part
    int iAdjustX = -(_m_iZoneSize-3)*32;

    if(_m_bShowHouse) ODraw(_m_oImage, _s_oHouseRect, px-70+iAdjustX, py+21);
    if(_m_bShowAntenna) ODraw(_m_oImage, _s_oAntennaRects[_m_dAntennaFrame.toInt()], px, py+29);
    if(_m_aiCargo!=null) {
      int i, iSize = _m_aiCargo.length;
      int iBaseX = _m_bShowHouse ? -50+iAdjustX : -78+iAdjustX;
      for(i=0; i<iSize; i++) {
        int iCargoType = 3-(_m_aiCargo[i]-1)~/5; //1..5=small container, 6..10, 11..15, 16..20+ = large container
        if(iCargoType<0) iCargoType=0;
        //if(iCargoType>3) iCargoType=3;
        ODraw(_m_oImage, _s_oCargoRects[iCargoType], px+iBaseX+((i~/3)*14), py+6+((i%3)*6));
      }
    }
    if(_m_bExtraLife) {
      int iBaseX = _m_bShowAntenna ? -8 : -4;
      ODraw(_m_oImage, _s_oExtraLifeRect, px+iBaseX, py+_s_oExtraLifeRect.height);
    }
  }

  void TakeExtraLife()
  {
    _m_bExtraLife = false;
  }

  int PopCargo()
  {
    int iCargo = -1;
    int i, iPos = _m_aiCargo.length-1;
    if(iPos>=0) {
      iCargo = _m_aiCargo[iPos];
      List<int> aiNewCargo = new List<int>(iPos);
      for(i=0; i<iPos; i++) aiNewCargo[i] = _m_aiCargo[i];
      _m_aiCargo = aiNewCargo;
    }
    return iCargo;
  }

  void PushCargo(int i_iWeight)
  {
    int i, iPos = _m_aiCargo.length;
    List<int> aiNewCargo = new List<int>(iPos+1);
    for(i=0; i<iPos; i++) aiNewCargo[i] = _m_aiCargo[i];
    aiNewCargo[iPos] = i_iWeight;
    _m_aiCargo = aiNewCargo;
  }

  int GetTotalCargo()
  {
    int iCargo = 0;
    if(_m_aiCargo!=null) {
      int i, iSize = _m_aiCargo.length;
      for(i=0; i<iSize; i++) iCargo+=_m_aiCargo[i];
    }
    return iCargo;
  }
}

/////////////////////////////////////////////////////////////////////////////////////////
class S_CheckPointInfo
{
  int iX1, iY1;
  int iX2, iY2;
}

class C_CheckPoint extends C_Object
{
  int _m_iPosX1, _m_iPosY1;
  int _m_iPosX2, _m_iPosY2;
  int _m_iCPNum;
  String _m_szString;

  C_TileMap _m_oMap;
  bool _m_bBlinkState;
  double _m_dBlinkTimer;
  int _m_iTextWidth;

  static C_Font s_oFont; //must be set externally
  static C_Image s_oCpImg; //must be set externally

  S_Rect _tmpRect = new S_Rect(0,0,0,0);

  C_CheckPoint(C_TileMap i_oMap, Point i_stP1, Point i_stP2, int i_iCPNum)
    : super()
  {
    _m_iPosX1 = i_stP1.x;
    _m_iPosY1 = i_stP1.y;
    _m_iPosX2 = i_stP2.x;
    _m_iPosY2 = i_stP2.y;
    _m_iCPNum = i_iCPNum;
    _m_szString = _m_iCPNum.toString();

    _m_oMap = i_oMap;
    _m_stScreenArea = _m_oMap.GetScreenRect();
    _m_dBlinkTimer = 0.0;
    _m_bBlinkState = false;

    _m_oImage = s_oCpImg;
    _m_stImageRect = null;

    //get textwidth
    _m_iTextWidth = _m_szString.length==1 ? 9 : 17; //simplified
  }

  void GetCheckPointInfo(S_CheckPointInfo o_pstCP)
  {
    int iSizeX = GetSizeX()~/2;
    int iSizeY = GetSizeY()~/2;

    o_pstCP.iX1 = _m_iPosX1+iSizeX;
    o_pstCP.iY1 = _m_iPosY1+iSizeY;
    o_pstCP.iX2 = _m_iPosX2+iSizeX;
    o_pstCP.iY2 = _m_iPosY2+iSizeY;
  }

  double PointDistanceToLineSeg(Vector2 p, Vector2 l0, Vector2 l1, Vector2 o_pstClosest)
  {
    Vector2 l0_l1;
    double dist;

    l0_l1 = l1 - l0;

    double l2 = l1.distanceToSquared(l0); // i.e. |l0-l1|^2 -  avoid a sqrt

    if(l2 < 0.1) {
      //just take l0, the line is too short
      dist = l0.distanceTo(p);
      if(o_pstClosest!=null) o_pstClosest.setFrom(l0);
    } else {
      // Consider the line extending the segment, parameterized as l0 + t (l1 - l0).
      // We find projection of point p onto the line.
      // It falls where t = [(p-l0) . (l1-l0)] / |l1-l0|^2
      double t = (p - l0).dot(l0_l1) / l2;
      if(t < 0.0) {
        // Beyond the 'l0' end of the segment
        dist = l0.distanceTo(p);
        if(o_pstClosest!=null) o_pstClosest.setFrom(l0);
      } else if(t > 1.0) {
        // Beyond the 'l1' end of the segment
        dist = l1.distanceTo(p);
        if(o_pstClosest!=null) o_pstClosest.setFrom(l1);
      } else {
        // Projection falls on the segment
        Vector2 projection = l0 + (l0_l1 * t);
        dist = p.distanceTo(projection);
        if(o_pstClosest!=null) o_pstClosest.setFrom(projection);
      }
    }

    return dist;
  }

  //true   player is in range of checkpoint
  //false  player is not in range of checkpoint
  final int CP_RANGE = 11;
  bool PlayerAtCP(C_Player i_oPlayer)
  {
    int iX = i_oPlayer.GetCenterPosX();
    int iY = i_oPlayer.GetCenterPosY();
    int iSizeX = GetSizeX()~/2;
    int iSizeY = GetSizeY()~/2;

    //calculate shortest distance from player to checkpoint line
    Vector2 p = new Vector2(iX.toDouble(), iY.toDouble());
    Vector2 l0 = new Vector2((_m_iPosX1+iSizeX).toDouble(), (_m_iPosY1+iSizeY).toDouble());
    Vector2 l1 = new Vector2((_m_iPosX2+iSizeX).toDouble(), (_m_iPosY2+iSizeY).toDouble());
    double dDist = PointDistanceToLineSeg(p, l0, l1, null);

    if(dDist < CP_RANGE) {
      return true;
    }
    return false;
  }

  void SetBlinkState(bool i_bBlinkState)
  {
    if(i_bBlinkState && !_m_bBlinkState) _m_dBlinkTimer = 0.0;
    _m_bBlinkState = i_bBlinkState;
  }

  void Update(double i_dTime)
  {
    _m_dBlinkTimer += i_dTime;
  }

  void Draw()
  {
    int px = _m_oMap.GetPosX();
    int py = _m_oMap.GetPosY();
    int iOffsetX = 0, iOffsetY = 0;
    _m_stScreenArea = _m_oMap.GetScreenRect();

    bool bDrawText = !_m_bBlinkState || (_m_bBlinkState && (_m_dBlinkTimer.toInt() % 650 < 400) );
    if(bDrawText) {
      //calc centeroffset
      iOffsetX = (px-10)+(_m_iTextWidth~/2);
      iOffsetY = (py-0);
      //^screenposition is (m_dPosX-p.x, m_dPosY-p.y)
    }
    m_dPosX = _m_iPosX1.toDouble();
    m_dPosY = _m_iPosY1.toDouble();
    ODraw(_m_oImage, null, px, py);
    if(bDrawText) {
      _tmpRect.x = _m_iPosX1-iOffsetX+_m_stScreenArea.x;
      _tmpRect.y = _m_iPosY1-iOffsetY+_m_stScreenArea.y;
      s_oFont.PutString(_tmpRect, false, _m_szString);
    }
    m_dPosX = _m_iPosX2.toDouble();
    m_dPosY = _m_iPosY2.toDouble();
    ODraw(_m_oImage, null, px, py);
    if(bDrawText) {
      _tmpRect.x = _m_iPosX2-iOffsetX+_m_stScreenArea.x;
      _tmpRect.y = _m_iPosY2-iOffsetY+_m_stScreenArea.y;
      s_oFont.PutString(_tmpRect, false, _m_szString);
    }
  }

}

/////////////////////////////////////////////////////////////////////////////////////////
class S_DoorInfo
{
  int iSize;
  bool bHorizontal;
  int iOpenedForTime;
  int iClosedForTime;
  int iOpeningSpeed; //pixels/sec
  int iClosingSpeed; //pixels/sec
  int iNumButtons; //0 -> interval opening
  List<Point> stButtonPos;
  List<Point> astWayPoints;
}

class C_Door extends C_Object
{
  //static
  static final List<S_Rect> _s_stVBaseRect = [new S_Rect(0,0,52,36),new S_Rect(0,36,52,36)];
  static final List<S_Rect> _s_stVDoorRect = [new S_Rect(23,0,6,6),new S_Rect(23,6,6,24),new S_Rect(23,30,6,6)];
  static final List<S_Rect> _s_stHBaseRect = [new S_Rect(52,20,36,52),new S_Rect(88,20,36,52)];
  static final List<S_Rect> _s_stHDoorRect = [new S_Rect(52,43,6,6),new S_Rect(58,43,24,6),new S_Rect(82,43,6,6)];
  static final List<S_Rect> _s_stButtonRect = [new S_Rect(52,0,23,19),new S_Rect(75,0,23,19)];

  //common
  C_TileMap    _m_oMap;
//  C_Replay     _m_oReplay;
//  C_BulletList _m_oBulletList;

  //animation
  bool m_bIsOpening;
  double m_dOpenPos;
  double m_dStateTime;

  //behavior
  S_DoorInfo m_stInfo;

  //images
  static C_Image _s_oDoorImg;
  static void InitImages(C_Image i_oDoorImg)
  {
    _s_oDoorImg = i_oDoorImg;
  }

  C_Door(C_TileMap i_oMap, int i_iX, int i_iY, S_DoorInfo i_stDoorInfo, int i_iID)
   : super()
  {
    m_iOwnerID = i_iID;
    _m_oMap = i_oMap;
    _m_stScreenArea = _m_oMap.GetScreenRect();

    m_iOwnerID = i_iID;
    m_dPosX = i_iX.toDouble();
    m_dPosY = i_iY.toDouble();
    _m_dVelX = _m_dVelY = _m_dAcceleration = 0.0;
    m_stInfo = i_stDoorInfo;
    _m_dDirection = m_stInfo.bHorizontal ? 270.0 : 0.0;

    _m_oImage = _s_oDoorImg;
    _m_stImageRect = null;

    m_bIsOpening = false;
    m_dOpenPos = 0.0;
    m_dStateTime = 0.0;

  }

  void Update(double i_dTime)
  {
    if(m_bIsOpening) {
      m_dOpenPos += i_dTime*(m_stInfo.iOpeningSpeed*0.001);
      if(m_dOpenPos>=m_stInfo.iSize) {
        m_dOpenPos = m_stInfo.iSize.toDouble();
        m_dStateTime += i_dTime;
        if(m_dStateTime>=m_stInfo.iOpenedForTime) {
          m_dStateTime = 0.0;
          m_bIsOpening = false;
        }
      }
    } else {
      m_dOpenPos -= i_dTime*(m_stInfo.iClosingSpeed*0.001);
      if(m_dOpenPos<=0) {
        m_dOpenPos = 0.0;
        m_dStateTime += i_dTime;
        if(m_dStateTime>=m_stInfo.iClosedForTime) {
          if(m_stInfo.iNumButtons==0) {
            m_dStateTime = 0.0;
            m_bIsOpening = true; //interval opening
          }
        }
      }
    }
  }

  void Draw()
  {
    int i;
    int px = _m_oMap.GetPosX();
    int py = _m_oMap.GetPosY();
    _m_stScreenArea = _m_oMap.GetScreenRect();

    double xx = m_dPosX;
    double yy = m_dPosY;
    S_Rect stRect;
    if(_m_dDirection==270.0) {
      ODraw(_m_oImage, _s_stVBaseRect[0], px, py);
      m_dPosX = xx; m_dPosY = yy+m_stInfo.iSize+36;
      ODraw(_m_oImage, _s_stVBaseRect[1], px, py);

      stRect = _s_stVDoorRect[1];
      int iSize = (m_stInfo.iSize-m_dOpenPos.toInt())~/2;
      int iPos = -6;
      while(iPos<iSize-6) {
        if(iPos+24>=iSize-6) stRect.height=(iSize-6)-iPos;
        m_dPosX = xx+23; m_dPosY = yy+36+iPos;
        ODraw(_m_oImage, stRect, px, py);
        m_dPosX = xx+23; m_dPosY = yy+m_stInfo.iSize+36-iPos-stRect.height;
        ODraw(_m_oImage, stRect, px, py);
        iPos+=stRect.height;
      }

      m_dPosX = xx+23; m_dPosY = yy+36+iPos;
      ODraw(_m_oImage, _s_stVDoorRect[2], px, py);
      m_dPosX = xx+23; m_dPosY = yy+m_stInfo.iSize+36-iPos-6;
      ODraw(_m_oImage, _s_stVDoorRect[0], px, py);
    } else {
      ODraw(_m_oImage, _s_stHBaseRect[0], px, py);
      m_dPosX = xx+m_stInfo.iSize+36; m_dPosY = yy;
      ODraw(_m_oImage, _s_stHBaseRect[1], px, py);

      stRect = _s_stHDoorRect[1];
      int iSize = (m_stInfo.iSize-m_dOpenPos.toInt())~/2;
      int iPos = -6;
      while(iPos<iSize-6) {
        if(iPos+24>=iSize-6) stRect.width=(iSize-6)-iPos;
        m_dPosX = xx+36+iPos; m_dPosY = yy+23;
        ODraw(_m_oImage, stRect, px, py);
        m_dPosX = xx+m_stInfo.iSize+36-iPos-stRect.width; m_dPosY = yy+23;
        ODraw(_m_oImage, stRect, px, py);
        iPos+=stRect.width;
      }

      m_dPosX = xx+36+iPos; m_dPosY = yy+23;
      ODraw(_m_oImage, _s_stHDoorRect[2], px, py);
      m_dPosX = xx+m_stInfo.iSize+36-iPos-6; m_dPosY = yy+23;
      ODraw(_m_oImage, _s_stHDoorRect[0], px, py);
    }
    for(i=0; i<m_stInfo.iNumButtons; i++) {
      m_dPosX = m_stInfo.stButtonPos[i].x.toDouble();
      m_dPosY = m_stInfo.stButtonPos[i].y.toDouble();
      ODraw(_m_oImage, _s_stButtonRect[m_bIsOpening ? 1 : 0], px, py);
    }

    m_dPosX = xx;
    m_dPosY = yy;
  }

  S_Rect _tmpRect = new S_Rect(0,0,0,0);
  bool CheckCollission(C_Object i_oObject, bool i_bIsBullet)
  {
    int i;
    _m_stScreenArea = _m_oMap.GetScreenRect();
    bool bResult = true;
    bool bAssignResult = true;

    double xx = m_dPosX;
    double yy = m_dPosY;
    do {
      if(_m_dDirection==270.0) {
        _m_stImageRect = _s_stVBaseRect[0];
        if(OCheckCollision2(i_oObject)) break;
        m_dPosX = xx; m_dPosY = yy+m_stInfo.iSize+36;
        _m_stImageRect = _s_stVBaseRect[1];
        if(OCheckCollision2(i_oObject)) break;

        int iSize = (m_stInfo.iSize-m_dOpenPos.toInt())~/2;
        _tmpRect.Set(0, 0, 6, iSize);

        m_dPosX = xx+23; m_dPosY = yy+36;
        if(C_Collision.Compare(null, m_dPosX.toInt(), m_dPosY.toInt(), i_oObject._m_oImage,
          i_oObject.m_dPosX.toInt(), i_oObject.m_dPosY.toInt(), _tmpRect, i_oObject._m_stImageRect)) break;
        m_dPosX = xx+23; m_dPosY = yy+m_stInfo.iSize+36-iSize;
        if(C_Collision.Compare(null, m_dPosX.toInt(), m_dPosY.toInt(), i_oObject._m_oImage,
          i_oObject.m_dPosX.toInt(), i_oObject.m_dPosY.toInt(), _tmpRect, i_oObject._m_stImageRect)) break;
      } else {
        _m_stImageRect = _s_stHBaseRect[0];
        if(OCheckCollision2(i_oObject)) break;
        m_dPosX = xx+m_stInfo.iSize+36; m_dPosY = yy;
        _m_stImageRect = _s_stHBaseRect[1];
        if(OCheckCollision2(i_oObject)) break;

        int iSize = (m_stInfo.iSize-m_dOpenPos.toInt())~/2;
        _tmpRect.Set(0,0,iSize,6);

        m_dPosX = xx+36; m_dPosY = yy+23;

        if(C_Collision.Compare(null, m_dPosX.toInt(), m_dPosY.toInt(), i_oObject._m_oImage,
          i_oObject.m_dPosX.toInt(), i_oObject.m_dPosY.toInt(), _tmpRect, i_oObject._m_stImageRect)) break;
        m_dPosX = xx+m_stInfo.iSize+36-iSize; m_dPosY = yy+23;
        if(C_Collision.Compare(null, m_dPosX.toInt(), m_dPosY.toInt(), i_oObject._m_oImage,
          i_oObject.m_dPosX.toInt(), i_oObject.m_dPosY.toInt(), _tmpRect, i_oObject._m_stImageRect)) break;
      }
      _m_stImageRect = _s_stButtonRect[0];
      for(i=0; i<m_stInfo.iNumButtons; i++) {
        m_dPosX = m_stInfo.stButtonPos[i].x.toDouble();
        m_dPosY = m_stInfo.stButtonPos[i].y.toDouble();
        if(OCheckCollision2(i_oObject)) {
          bAssignResult = false;
          if(i_bIsBullet) {
            m_dStateTime = 0.0;
            m_bIsOpening = !m_bIsOpening; //toggle
          }
        }
      }
      if(bAssignResult) bResult = false;
    } while(false);

    m_dPosX = xx;
    m_dPosY = yy;
    return bResult;
  }

}

/////////////////////////////////////////////////////////////////////////////////////////
class S_EnemyInfo
{
  int iEnemyType;
  int iAngle;
  int iFireInterval;
  int iSpeed;
  List<Point> astWayPoints;
}

class C_ComputerEnemy extends C_PlayerBase
{
  //static
  //enemy properties


  //unanimated enemies (rectangles are 4 directions (0, 90, 180, 270))
  static final List<S_Rect> _ENEMY6_RECT = [new S_Rect(0,14,14,14),new S_Rect(14,0,14,14),new S_Rect(14,14,14,14),new S_Rect(0,0,14,14)];
  static final List<Point> _ENEMY6_FIREPOINT = [new Point(13,6),new Point(6,13),new Point(0,6),new Point(6,0)];
  //animated enemies, 1 direction (rectangles are each frame)
  static final List<S_Rect> _ENEMY4_RECT = [
    new S_Rect(0,0,64,32),new S_Rect(64,0,64,32),new S_Rect(128,0,64,32),new S_Rect(192,0,64,32),
    new S_Rect(0,32,64,32),new S_Rect(64,32,64,32),new S_Rect(128,32,64,32),new S_Rect(192,32,64,32),
    new S_Rect(0,64,64,32),new S_Rect(64,64,64,32),new S_Rect(128,64,64,32),new S_Rect(192,64,64,32)];
  static final Point _ENEMY4_FIREPOINT = new Point(32,16);
  static final List<S_Rect> _ENEMY7_RECT = [
    new S_Rect(0,0,64,64),new S_Rect(64,0,64,64),new S_Rect(128,0,64,64),new S_Rect(192,0,64,64),
    new S_Rect(0,64,64,64),new S_Rect(64,64,64,64),new S_Rect(128,64,64,64),new S_Rect(192,64,64,64),
    new S_Rect(0,128,64,64),new S_Rect(64,128,64,64),new S_Rect(128,128,64,64),new S_Rect(192,128,64,64)];
  static final Point _ENEMY7_FIREPOINT = new Point(32,32);
  //enemies with animated fireing, 4 directions
  static final List<S_Rect> _ENEMY0_RECT = [
    new S_Rect(0,16,16,12),new S_Rect(24+0,16,16,12), new S_Rect(12,0,12,16),new S_Rect(24+12,0,12,16),
    new S_Rect(0,28,16,12),new S_Rect(24+0,28,16,12), new S_Rect(0,0,12,16),new S_Rect(24+0,0,12,16)];
  static final List<Point> _ENEMY0_FIREPOINT = [new Point(16,5), new Point(5,16), new Point(0,5), new Point(5,0)];
  static final List<S_Rect> _ENEMY2_RECT = [
    new S_Rect(0,16,16,12),new S_Rect(24+0,16,16,12), new S_Rect(12,0,12,16),new S_Rect(24+12,0,12,16),
    new S_Rect(0,28,16,12),new S_Rect(24+0,28,16,12), new S_Rect(0,0,12,16),new S_Rect(24+0,0,12,16)];
  static final List<Point> _ENEMY2_FIREPOINT = [new Point(16,5), new Point(5,16), new Point(0,5), new Point(5,0)];
  static final List<S_Rect> _ENEMY1_RECT = [
    new S_Rect(14,14,14,24),new S_Rect(28+14,14,14,24), new S_Rect(0,38,24,14),new S_Rect(28+0,38,24,14),
    new S_Rect(0,14,14,24),new S_Rect(28+0,14,14,24), new S_Rect(0,0,24,14),new S_Rect(28+0,0,24,14)];
  static final List<Point> _ENEMY1_FIREPOINT = [new Point(14,12), new Point(12,14), new Point(0,12), new Point(12,0)];
  static final List<S_Rect> _ENEMY3_RECT = [
    new S_Rect(14,14,14,24),new S_Rect(28+14,14,14,24), new S_Rect(0,38,24,14),new S_Rect(28+0,38,24,14),
    new S_Rect(0,14,14,24),new S_Rect(28+0,14,14,24), new S_Rect(0,0,24,14),new S_Rect(28+0,0,24,14)];
  static final List<Point> _ENEMY3_FIREPOINT = [new Point(14,12), new Point(12,14), new Point(0,12), new Point(12,0)];
  static final List<S_Rect> _ENEMY5_RECT = [
    new S_Rect(0,26,13,22),new S_Rect(0,48,13,22), new S_Rect(0,13,22,13),new S_Rect(22,13,22,13),
    new S_Rect(13,26,13,22),new S_Rect(13,48,13,22), new S_Rect(0,0,22,13),new S_Rect(22,0,22,13)];
  static final List<Point> _ENEMY5_FIREPOINT = [ new Point(13,4),new Point(13,18), new Point(4,13),new Point(18,13), new Point(0,4),new Point(0,18), new Point(4,0),new Point(18,0)];

  static final int SENEMY_FIRERANGE = 450;
  static final int SENEMY_FI_TABLESIZE = 30;
  static final List<int> SENEMY_FIREINTERVALTABLE = [
    300,  300,  400,  500,  500,  700,  850,  900,  1000, 1100,
    1200, 1500, 1700, 1800, 2000, 2100, 2200, 2300, 2450, 2600,
    2800, 3000, 3500, 3800, 4000, 5000, 6000, 7000, 8000, 8000];

  //enemy properties
  static final List<int>  SENEMY_HITSTOKILL        = [4, 5, -1, -1, 8, 4, 4, 6]; //-1=immortal
  static final List<int>  SENEMY_SCOREPOINTS       = [10, 20, 0, 0, 20, 15, 25, 25];
  static final List<int>  SENEMY_NUMBULLETS        = [1, 3, 1, 3, 1, 2, 5, 8];
  static final List<int>  SENEMY_BULLETSPEED       = [190, 160, 190, 160, 110, 90, 120, 140];
  static final List<bool> SENEMY_RANDOMBULLETANGLE = [false, false, false, false, true, false, false, false];
  static final List<List<int>>  SENEMY_BULLETANGLE = [
    [0,0,0,0,0,0,0,0], [-50,0,50,0,0,0,0,0], [0,0,0,0,0,0,0,0], [-50,0,50,0,0,0,0,0],
    [0,0,0,0,0,0,0,0], [0,0,0,0,0,0,0,0], [-70,-35,0,35,70,0,0,0], [-180,-135,-90,-45,0,45,90,135]];
  static final List<int>  SENEMY_NUMFRAMES = [1, 1, 1, 1, 12, 1, 1, 12]; //valid for type 4 and 7 only

  static C_Object s_oRangeObj; //player

  //common
  C_TileMap    _m_oMap;
  C_BulletList _m_oBulletList;

  //movement
  int _m_iNumWayPoints, _m_iCurWP, _m_iSpeed;
  List<Point> _m_astWayPointList;
  double _m_dWayTime;

  //animation
  double _m_dFrameNr;
  double _m_dFireAnimTime = 0.0;
  List<S_Rect> _m_astAnimRects;

  //enemy specific
  int _m_iEnemyType;
  int _m_iHitsLeft;      //hits enemy can take before it gets killed
  int _m_iFireInterval;
  double _m_dFireTime = 0.0;
  Point _m_stFirePoint;
  bool _m_bAlive, _m_bFinished; //explosion ready after enemy killed

  //images
  static C_Image _s_oEnemy0Img;
  static C_Image _s_oEnemy1Img;
  static C_Image _s_oEnemy2Img;
  static C_Image _s_oEnemy3Img;
  static C_Image _s_oEnemy4Img;
  static C_Image _s_oEnemy5Img;
  static C_Image _s_oEnemy6Img;
  static C_Image _s_oEnemy7Img;
  static void InitImages(C_Image i_oEnemy0Img, C_Image i_oEnemy1Img, C_Image i_oEnemy2Img, C_Image i_oEnemy3Img, C_Image i_oEnemy4Img, C_Image i_oEnemy5Img, C_Image i_oEnemy6Img, C_Image i_oEnemy7Img)
  {
    _s_oEnemy0Img = i_oEnemy0Img;
    _s_oEnemy1Img = i_oEnemy1Img;
    _s_oEnemy2Img = i_oEnemy2Img;
    _s_oEnemy3Img = i_oEnemy3Img;
    _s_oEnemy4Img = i_oEnemy4Img;
    _s_oEnemy5Img = i_oEnemy5Img;
    _s_oEnemy6Img = i_oEnemy6Img;
    _s_oEnemy7Img = i_oEnemy7Img;
  }

  C_ComputerEnemy(C_TileMap i_oMap, C_BulletList i_oBulletList, S_EnemyInfo i_stEnemyInfo, int i_iID)
    : super()
  {
    m_iOwnerID = i_iID;
    _m_oMap = i_oMap;
    _m_oBulletList = i_oBulletList;

    _m_iEnemyType = i_stEnemyInfo.iEnemyType;
    _m_iFireInterval = i_stEnemyInfo.iFireInterval;
    _m_dDirection = i_stEnemyInfo.iAngle.toDouble();
    _m_iSpeed = i_stEnemyInfo.iSpeed;
    _m_iNumWayPoints = i_stEnemyInfo.astWayPoints.length;
    _m_astWayPointList = i_stEnemyInfo.astWayPoints;
    m_dPosX = _m_astWayPointList[0].x.toDouble();
    m_dPosY = _m_astWayPointList[0].y.toDouble();
    _m_dVelX = _m_dVelY = _m_dAcceleration = 0.0;
    _m_iCurWP = 1; //after 0
    _m_dWayTime = 0.0;
    _m_dFrameNr  = 0.0;
    _m_dFireAnimTime = 0.0;

    _m_bAlive     = true;
    _m_bFinished = false;
    _m_iHitsLeft = SENEMY_HITSTOKILL[_m_iEnemyType];
    switch(_m_iEnemyType) {
      case 0:
        _m_oImage = _s_oEnemy0Img;
        _m_astAnimRects = _ENEMY0_RECT;
        _m_stImageRect = _ENEMY0_RECT[i_stEnemyInfo.iAngle~/90];
        _m_stFirePoint = _ENEMY0_FIREPOINT[i_stEnemyInfo.iAngle~/90];
      break;
      case 1:
        _m_oImage = _s_oEnemy1Img;
        _m_astAnimRects = _ENEMY1_RECT;
        _m_stImageRect = _ENEMY1_RECT[i_stEnemyInfo.iAngle~/90];
        _m_stFirePoint = _ENEMY1_FIREPOINT[i_stEnemyInfo.iAngle~/90];
      break;
      case 2:
        _m_oImage = _s_oEnemy2Img;
        _m_astAnimRects = _ENEMY2_RECT;
        _m_stImageRect = _ENEMY2_RECT[i_stEnemyInfo.iAngle~/90];
        _m_stFirePoint = _ENEMY2_FIREPOINT[i_stEnemyInfo.iAngle~/90];
      break;
      case 3:
        _m_oImage = _s_oEnemy3Img;
        _m_astAnimRects = _ENEMY3_RECT;
        _m_stImageRect = _ENEMY3_RECT[i_stEnemyInfo.iAngle~/90];
        _m_stFirePoint = _ENEMY3_FIREPOINT[i_stEnemyInfo.iAngle~/90];
      break;
      case 4:
        _m_oImage = _s_oEnemy4Img;
        _m_astAnimRects = _ENEMY4_RECT;
        _m_stImageRect = _ENEMY4_RECT[0];
        _m_stFirePoint = _ENEMY4_FIREPOINT;
        break;
      case 5:
        _m_oImage = _s_oEnemy5Img;
        _m_astAnimRects = _ENEMY5_RECT;
        _m_stImageRect = _ENEMY5_RECT[i_stEnemyInfo.iAngle~/90];
        _m_stFirePoint = _ENEMY5_FIREPOINT[i_stEnemyInfo.iAngle~/90];
        break;
      case 6:
        _m_oImage = _s_oEnemy6Img;
        _m_astAnimRects = _ENEMY6_RECT;
        _m_stImageRect = _ENEMY6_RECT[i_stEnemyInfo.iAngle~/90];
        _m_stFirePoint = _ENEMY6_FIREPOINT[i_stEnemyInfo.iAngle~/90];
        break;
      case 7:
        _m_oImage = _s_oEnemy7Img;
        _m_astAnimRects = _ENEMY7_RECT;
        _m_stImageRect = _ENEMY7_RECT[0];
        _m_stFirePoint = _ENEMY7_FIREPOINT;
        break;
    }

  }

  bool InFireRange(C_Object i_oFireRange)
  {
    double dDist = GetDistanceTo(i_oFireRange);

    if(dDist < SENEMY_FIRERANGE) {
      return true;
    }
    return false;
  }

  C_Bullet CreateBullet(int i_iIndex)
  {
    double dAngle = _m_dDirection+SENEMY_BULLETANGLE[_m_iEnemyType][i_iIndex];
    double dTemp = dAngle*(PI/180);
    double dSin = sin(dTemp);
    double dCos = cos(dTemp);
    double dPosX = m_dPosX + _m_stFirePoint.x;
    double dPosY = m_dPosY + _m_stFirePoint.y;
    double dVelX = dCos * SENEMY_BULLETSPEED[_m_iEnemyType];
    double dVelY = dSin * SENEMY_BULLETSPEED[_m_iEnemyType];
    if(_m_iEnemyType==7) {
      //this is the correct thing to do, but it looks better
      // for most enemies to skip this
      dVelX += _m_dVelX;
      dVelY += _m_dVelY;
    }

    return new C_Bullet(_m_oMap, dPosX, dPosY, dVelX, dVelY, dAngle, m_iOwnerID);
  }

  int Update(double i_dTime)
  {
    int iUId;
    int i, iPlaySound = -1;
    C_Bullet oBullet;
    bool bFireBullet = false;

    if(!_m_bAlive) {
      _m_bFinished = UpdateExplosion(i_dTime);
      if(_m_bFinished) return -2;
      return -1;
    }

    if(_m_bAlive) {
      _m_dFireTime -= i_dTime;
      int iBulletUID;
      if(_m_dFireTime <= 0) { //fire bullet, send to network
        if(_m_iFireInterval == -1) {
          _m_dFireTime = (SENEMY_FIREINTERVALTABLE[C_Object.rand.nextInt(SENEMY_FI_TABLESIZE)]).toDouble();
        } else _m_dFireTime = _m_iFireInterval.toDouble();

        if(InFireRange(s_oRangeObj)) {
          iPlaySound = 0; //bullet sound

          if(SENEMY_RANDOMBULLETANGLE[_m_iEnemyType]) {
            _m_dDirection = C_Object.rand.nextInt(359).toDouble();
          }

          for(i=0; i<SENEMY_NUMBULLETS[_m_iEnemyType]; i++) {
            if(_m_iEnemyType==5) _m_stFirePoint = _ENEMY5_FIREPOINT[2*(_m_dDirection~/90)+i];
            oBullet = CreateBullet(i);
            C_PlayerBase.s_iBulletCounter++;
            iUId = m_iOwnerID | (C_PlayerBase.s_iBulletCounter << 8);
            oBullet.SetUId(iUId);
            //if(i==0) m_stMsg1.iBulletUniqeValBase = iUId; //additional bullets by this enemy will be calculated by receiver
            _m_oBulletList.Add(oBullet);
          }
          bFireBullet = true;
        }
      }

      if(_m_oBulletList.CheckCollision(this)) {
        if(_m_iHitsLeft!=-1) _m_iHitsLeft--;
        iPlaySound = 4; //hit sound
        if(_m_iHitsLeft <= 0 && _m_iHitsLeft!=-1) {
          _m_bAlive = false;
          _m_bCanCollide = false;
          iPlaySound = 1; //explode sound
//          iResult = iBulletUID & 255;
        }
      }
      Move(i_dTime);

      //animated?
      if(_m_iEnemyType==4 || _m_iEnemyType==7) {
        _m_dFrameNr += i_dTime*0.021; //21 fps anim
        int iFrameNr = _m_dFrameNr.toInt();
        if(iFrameNr >= SENEMY_NUMFRAMES[_m_iEnemyType]) {
          _m_dFrameNr = 0.0; //restart anim
          iFrameNr = 0;
        }
        _m_stImageRect = _m_astAnimRects[iFrameNr];
      }

      //animated fireing
      if(_m_iEnemyType==5 || _m_iEnemyType==0 || _m_iEnemyType==2 || _m_iEnemyType==1 || _m_iEnemyType==3) {
        if(bFireBullet) _m_dFireAnimTime = 250.0; //250 ms
        _m_dFireAnimTime -= i_dTime;
        int iRect = 2*(_m_dDirection~/90);
        _m_stImageRect = _m_astAnimRects[iRect];
        if(_m_dFireAnimTime<=0) _m_dFireAnimTime = 0.0;
        else _m_stImageRect = _m_astAnimRects[iRect+1];
      }
    }

    if(iPlaySound != -1) {
      CalcSoundVolPan(C_PlayerBase._s_oListner);
      C_Sound.s_oSound.PlaySound(iPlaySound, _m_dVol, _m_dPan, false);
    }

    return 0;
  }

  void Move(double i_dTime)
  {
    if(_m_iNumWayPoints>1) { //move enemy
      _m_dWayTime -= i_dTime;
      if(_m_dWayTime <= 0) {
        double dDistX, dDistY, dDist;

        dDistX = _m_astWayPointList[_m_iCurWP].x - m_dPosX;
        dDistY = _m_astWayPointList[_m_iCurWP].y - m_dPosY;

        dDist = sqrt(dDistX*dDistX + dDistY*dDistY);
        _m_dWayTime = dDist / _m_iSpeed;
        if(_m_dWayTime == 0.0) _m_dWayTime = 0.8; //stand still for 0.8s if no destination!

        _m_dVelX = dDistX / _m_dWayTime;
        _m_dVelY = dDistY / _m_dWayTime;
        _m_dWayTime *= 1000; //make it milliseconds
        _m_iCurWP = (_m_iCurWP+1) % _m_iNumWayPoints;
      }
      OUpdate(i_dTime);
    }
  }

  void Draw()
  {
    int px = _m_oMap.GetPosX();
    int py = _m_oMap.GetPosY();
    _m_stScreenArea = _m_oMap.GetScreenRect();

    if(_m_bAlive) ODraw(_m_oImage, _m_stImageRect, px, py);
    else DrawExplosion(px, py);
  }

  int GetScoreValue()
  {
    return SENEMY_SCOREPOINTS[_m_iEnemyType];
  }

}
