
part of web_play;


class C_Viewport
{
  List<int> m_aiPlayerStartPosX = new List<int>(8), m_aiPlayerStartPosY = new List<int>(8);
  List<C_LandingZone> m_oLandingZList = new List<C_LandingZone>();
  List<C_CheckPoint> m_oCheckPList = new List<C_CheckPoint>();
  List<C_ComputerEnemy> m_oCompEnemyList = new List<C_ComputerEnemy>();
  List<C_Door> m_oDoorList = new List<C_Door>();
  C_BulletList m_oBulletList = new C_BulletList();
  C_Player       m_oPlayer;
  C_TileMap      m_oMap;
  int            m_iNumLapsToRace;

  static C_Font _s_oFont;
  static C_Graph _s_oGraph;

  static C_Image _m_oCargoFuel;
  static C_Image _m_oLapsTime;
  static C_Image s_oShipImg;

  static final int MAXSPACEINHOLDUNITS = 3;
  static final int MAXSPACEINHOLDWEIGHT = 50;

  bool _m_bTimeCounting = false;
  double _m_dTotalTime = 0.0;
  double _m_dLastNewLapTime;
  double _m_dTotalTimePlayed;
  bool _m_bGameFinished = false;
  int _m_iTotalLaps = -1;

  static List<bool> s_lKeyState;
  static List<bool> s_lTouchState;

  bool IsRace() {return m_oMap.GetType()==m_oMap.MAP_RACE;}
  bool IsMission() {return (m_oMap.GetType()==m_oMap.MAP_MISSION) || (m_oMap.GetType()==m_oMap.MAP_MISSION_COOP);}
  bool IsDogfight() {return m_oMap.GetType()==m_oMap.MAP_DOGFIGHT;}

  static void InitImagesAndStuff(C_Graph i_oBackBuffer, C_Image i_oShipImg,
    C_Image i_oExplosionImg, C_Image i_oBulletImg, C_Image i_oLandingZoneImg, C_Image i_oCpImg,
    C_Image i_oE0, C_Image i_oE1, C_Image i_oE2, C_Image i_oE3, C_Image i_oE4,
    C_Image i_oE5, C_Image i_oE6, C_Image i_oE7, C_Image i_oDoorImg,
    C_Image i_oCargoFuel, C_Image i_oLapsTime, C_Font i_oFont, List<bool> i_lKeyState, List<bool> i_lTouchState)
  {
    s_lKeyState = i_lKeyState;
    s_lTouchState = i_lTouchState;
    _s_oGraph = i_oBackBuffer;
    s_oShipImg = i_oShipImg;
    C_PlayerBase.InitExplosionImage(i_oExplosionImg);
    C_Bullet.s_oBulletImg = i_oBulletImg;
    C_LandingZone.InitImage(i_oLandingZoneImg);
    C_ComputerEnemy.InitImages(i_oE0, i_oE1, i_oE2, i_oE3, i_oE4, i_oE5, i_oE6, i_oE7);
    C_CheckPoint.s_oCpImg = i_oCpImg;
    C_CheckPoint.s_oFont = i_oFont;
    C_Door.InitImages(i_oDoorImg);

    _s_oFont = i_oFont;

    _m_oCargoFuel = i_oCargoFuel;
    _m_oLapsTime = i_oLapsTime;
  }

  void InitPlayersAndSetMap(C_TileMap i_oMap)
  {
    m_oMap = i_oMap;

    _m_bTimeCounting = false;
    _m_dTotalTime = 0.0;
    _m_dLastNewLapTime = 0.0;
    m_oPlayer = new C_Player(this, 0, "You", s_oShipImg, _STATUSCOLOR[0], m_oMap, m_oBulletList, m_aiPlayerStartPosX[0], m_aiPlayerStartPosY[0], m_oMap.MapType()==3 ? -1 : 5, s_lKeyState, s_lTouchState);
    C_ComputerEnemy.s_oRangeObj = m_oPlayer;

    ReplayFollow(false);

    _m_dTotalTimePlayed = 0.0;

    _m_bGameFinished = false;
    _m_iTotalLaps = -1;
    if(IsRace()) {
      _m_iTotalLaps = m_iNumLapsToRace;
    }
  }

  //changes the draw area
  // the whole window size is now used for drawing
  void SetSize(int i_iWidth, int i_iHeight)
  {
    int w, h;
    S_Rect stNewRect = new S_Rect(0, 0, i_iWidth, i_iHeight);
    w = m_oMap._m_iWidth*m_oMap._m_iTileSize;
    h = m_oMap._m_iHeight*m_oMap._m_iTileSize;
    if(i_iWidth>w) {
      stNewRect.x = (i_iWidth-w)~/2;
      stNewRect.width = w;
    }
    if(i_iHeight>h) {
      stNewRect.y = (i_iHeight-h)~/2;
      stNewRect.height = h;
    }
    _MAINPLAYERSTATUSPOS = new Point(stNewRect.x+4,     /*-50*/-50+stNewRect.y+stNewRect.height);
    _STATUSPOS           = new Point(stNewRect.x+120+2, /*-50*/-24+stNewRect.y+stNewRect.height);

    m_oMap.SetScreenRect(stNewRect);
  }

  void ReplayFollow(bool i_bNext)
  {
    C_Player oPlayer = m_oPlayer;
    C_PlayerBase.SetListner(oPlayer);
    if(oPlayer!=null) {
      S_Rect stRect = m_oMap.GetScreenRect();
      int iPosX = oPlayer.GetCenterPosX() - (stRect.width~/2);
      int iPosY = oPlayer.GetCenterPosY() - (stRect.height~/2);
      m_oMap.MoveAbsolute(iPosX, iPosY);
    }
  }

  void SoundOn(bool i_bSound)
  {
    if(m_oPlayer!=null) m_oPlayer.SoundOn(i_bSound);
  }

  String GetTimeAsString(double dTime)
  {
    int iSec = dTime ~/ 1000;
    int i100 = (dTime~/10) % 100;
    String szString = iSec.toString();
    szString += ".";
    if(i100 <10) szString += "0";
    szString += i100.toString();
    return szString;
  }

  //the main update loop
  // - updates all time based movements for all objects
  // - updates all time based actions for all objects (checkpoints visited for example)
  // - checks collissions for all objects
  int Update(double i_dTime)
  {
    int i, iSize;
    int iGameStatus = 0;

    if(!_m_bGameFinished) _m_dTotalTimePlayed += i_dTime;

    //update fade out (removes click/pop in looping sounds that are stopped)
    C_Player.UpdateFadeOut(i_dTime);

    //update doors
    iSize = m_oDoorList.length;
    for(i=0; i<iSize; i++) {
      C_Door oDoor = m_oDoorList[i];
      oDoor.Update(i_dTime);

      if(oDoor.CheckCollission(m_oPlayer, false)) {
        m_oPlayer.Kill();
      }
    }

    //update bullets
    m_oBulletList.Update(i_dTime);
    C_Bullet oBullet = m_oBulletList.GetNext(true);
    while(oBullet!=null) {
      for(i=0; i<iSize; i++) {
        C_Door oDoor = m_oDoorList[i];
        if(oDoor.CheckCollission(oBullet, true)) {
          m_oBulletList.Remove(oBullet.GetUId());
        }
      }
      oBullet = m_oBulletList.GetNext(false);
    }

    //update player movements
    if(m_oPlayer!=null) m_oPlayer.Update(i_dTime);

    //update landingzones
    iSize = m_oLandingZList.length;
    for(i=0; i<iSize; i++) {
      C_LandingZone oZone = m_oLandingZList[i];
      oZone.UpdateLanding(m_oPlayer, i_dTime);
      oZone.UpdateFuel(m_oPlayer, i_dTime);
    }

    //update enemies
    iSize = m_oCompEnemyList.length;
    for(i=0; i<iSize; i++) {
      C_ComputerEnemy oEnemy = m_oCompEnemyList[i];
      int iResult = oEnemy.Update(i_dTime);
      if(iResult==-2) { //remove enemy
        m_oCompEnemyList.removeAt(i);
        i--; iSize--; //compensate for remove to be able to keep on looping
      }
    }

    //update checkpoints
    iSize = m_oCheckPList.length;
    if(iSize>0) { //there are checkpoints (racemap)
      C_CheckPoint oCP;
      for(i=0; i<iSize; i++) {
        oCP = m_oCheckPList[i];
        oCP.Update(i_dTime);
        //start counting if any checkpoint is passed to prevent clearing the map from enemies by going backwards
        if(_m_dTotalTime == 0.0) {
          if(oCP.PlayerAtCP(m_oPlayer)) _m_bTimeCounting = true;
        }
      }
      if(_m_bTimeCounting) _m_dTotalTime += i_dTime;

      i = m_oPlayer.m_iCurCP;
      if(m_oCheckPList[i].PlayerAtCP(m_oPlayer)) {
        m_oCheckPList[i].SetBlinkState(false);
        if(_m_bTimeCounting) {
          if(++i == iSize) { //new lap
            i = 0;
            m_oPlayer.m_iCurLap++;

            //finished?
            if(m_oPlayer.m_iCurLap == _m_iTotalLaps) {
              m_oPlayer.m_iCurCP = 0; //reset
              _m_bTimeCounting = false;
              C_Sound.s_oSound.PlaySound(6, 1.0, 0.0, false);
            }

            //best lap time calculation
            double dThisLapTime = _m_dTotalTime-_m_dLastNewLapTime;
            if(dThisLapTime<m_oPlayer.m_dBestLapTime) {
              m_oPlayer.m_dBestLapTime = dThisLapTime;
            }
            _m_dLastNewLapTime = _m_dTotalTime;
          }
          if(_m_bTimeCounting) {
            C_Sound.s_oSound.PlaySound(5, 1.0, 0.0, false);
            m_oPlayer.m_iCurCP = i;
            m_oCheckPList[i].SetBlinkState(true);
          }
        }
      }
    }

    //check for player collisions
    {
      //player -> map collision
      if(m_oMap.CheckCollision(m_oPlayer)) {
        //player KILLEDBY_SELF
        m_oPlayer.Kill();
      }
      //player -> bullets collision
      if(!m_oPlayer.FreeFromBullets()) {

        if(m_oBulletList.CheckCollision(m_oPlayer)) {
          //player KILLEDBY_BULLET (iBulletUID)
          m_oPlayer.AddScore(-10);
          m_oPlayer.Kill();
        }
        //player -> computer enemy collision
        iSize = m_oCompEnemyList.length;
        for(i=0; i<iSize; i++) {
          if(m_oCompEnemyList[i].OCheckCollision2(m_oPlayer)) {
            m_oPlayer.Kill();
          }
        }
      }
    }

    if(IsMission() && CargoEndCondition(i_dTime)) {
      iGameStatus = -2;
      _m_bGameFinished = true;
    }
    if(IsRace() && ((m_oPlayer.m_iCurLap == _m_iTotalLaps) && !_m_bTimeCounting)) {
      iGameStatus = -2;
      _m_bGameFinished = true;
    }

    //set new map position
    ReplayFollow(false);

    return iGameStatus;
  }

  //checks if all cargo is delivered
  bool CargoEndCondition(double dTime)
  {
    //check lifes
    if(m_oPlayer._m_iNumLifes > 0) {

      //check all zones
      int iCargoInGame = 0;
      int i, iSize = m_oLandingZList.length;
      for(i=0; i<iSize; i++) {
        iCargoInGame += m_oLandingZList[i].GetTotalCargo();
      }
      if(iCargoInGame>0) return false;

      if(m_oPlayer.CargoWeightInHold()>0) return false;
    }

    return true;
  }

  void Draw()
  {
    int i, iSize;

    //draw map
    m_oMap.Draw();

    //draw doors
    iSize = m_oDoorList.length;
    for(i=0; i<iSize; i++) {
      C_Door oDoor = m_oDoorList[i];
      oDoor.Draw();
    }

    //draw checkpoints
    iSize = m_oCheckPList.length;
    for(i=0; i<iSize; i++) {
      C_CheckPoint oCP = m_oCheckPList[i];
      oCP.Draw();
    }

    //draw landingzones
    iSize = m_oLandingZList.length;
    for(i=0; i<iSize; i++) {
      C_LandingZone oZone = m_oLandingZList[i];
      oZone.Draw();
    }

    //draw enemies
    iSize = m_oCompEnemyList.length;
    for(i=0; i<iSize; i++) {
      C_ComputerEnemy oEnemy = m_oCompEnemyList[i];
      oEnemy.Draw();
    }

    //draw players
    if(m_oPlayer!=null) m_oPlayer.Draw();

    //draw bullets
    m_oBulletList.Draw();

    //draw info
    _DrawAllPlayersStatus();

    _DrawAdditionalPlayerStatus(0);
  }

  int GetScore() //not valid for race
  {
    int iScore = 0;
    if(m_oPlayer!=null) {
      int iLifes = m_oPlayer.GetNumLives();
      if(iLifes<0) iLifes = 0;
      iScore = (m_oPlayer.m_iScore+iLifes*50)*1000;
      if(m_oMap.MapType()==1) { //mission

        iScore -= (_m_dTotalTimePlayed~/2); //long time is bad in mission
      }
    }
    return iScore;
  }
  int GetRaceTime()
  {
    if(this.m_oCheckPList.length>0 && !_m_bTimeCounting) {
      return _m_dTotalTime.toInt();
    }

    return -1;
  }

  static List<Vector4> _STATUSCOLOR = [
    new Vector4(0xAD/255.0,0x16/255.0,0x16/255.0,1.0),
    new Vector4(0x46/255.0,0xB3/255.0,0x9E/255.0,1.0),
    new Vector4(0x16/255.0,0xAE/255.0,0x16/255.0,1.0),
    new Vector4(0x19/255.0,0x4F/255.0,0xBF/255.0,1.0),
    new Vector4(0xC4/255.0,0xAF/255.0,0x46/255.0,1.0),
    new Vector4(0x9E/255.0,0x16/255.0,0x98/255.0,1.0),
    new Vector4(0xCD/255.0,0xCD/255.0,0xCD/255.0,1.0),
    new Vector4(0x93/255.0,0x9F/255.0,0x16/255.0,1.0)
  ];
  static Point _MAINPLAYERSTATUSPOS = new Point(4,     -50+600);
  static Point _STATUSPOS           = new Point(120+2, -24+600);
  static Vector4 _MAINPLAYERSTATUSCOLOR1 = new Vector4(0x09/255.0, 0x6f/255.0, 0xcc/255.0, 1.0);
  static Vector4 _MAINPLAYERSTATUSCOLOR2 = new Vector4(0xcc/255.0, 0x0a/255.0, 0x2e/255.0, 1.0);

  static Vector4 _GREYSTATUSCOLOR = new Vector4(0.50, 0.50, 0.50, 0.60);
  static Vector4 _WHITESTATUSCOLOR = new Vector4(1.00, 1.00, 1.00, 1.00);
  S_Rect _m_tmpRect1 = new S_Rect(0, 0, 0, 0);
  S_Rect _m_tmpRect2 = new S_Rect(0, 0, 0, 0);
  void _DrawAllPlayersStatus()
  {
    int iNumPlayers = 1;

    _m_tmpRect2.x = 0; _m_tmpRect2.y = 0; _m_tmpRect2.width = 48; _m_tmpRect2.height = 48;

    C_Player oShip = m_oPlayer;
    if(oShip!=null) {

      _m_tmpRect1.x = _STATUSPOS.x;
      _m_tmpRect1.y = _STATUSPOS.y;
      _m_tmpRect1.width = 224;
      _m_tmpRect1.height = 16;
      if( m_oCheckPList.length>0 ) _m_tmpRect1.x -= 48;
      _s_oGraph.DrawRectangle2D(_m_tmpRect1, _GREYSTATUSCOLOR);

      _s_oFont.SetColor(_STATUSCOLOR[0]);
      _m_tmpRect1.width = 0;
      _m_tmpRect1.height = 0;
      if( m_oCheckPList.length>0 ) {
        //race:             name, best lap time, current lap and cp
        double dBestLap = oShip.m_dBestLapTime>999000.0 ? 999000.0 : oShip.m_dBestLapTime;
        _m_tmpRect1.x += 2;   _s_oFont.PutString(_m_tmpRect1, false, oShip.m_szName);
        _m_tmpRect1.x += 100; _s_oFont.PutString(_m_tmpRect1, false, GetTimeAsString(dBestLap));
        _m_tmpRect1.x += 62;  _s_oFont.PutString(_m_tmpRect1, false,
          "Lap "+oShip.m_iCurLap.toString()+"["+oShip.m_iCurCP.toString()+"]");
      } else {
        //mission/dogfight: name, score
        _m_tmpRect1.x += 2;   _s_oFont.PutString(_m_tmpRect1, false, oShip.m_szName);
        _m_tmpRect1.x += 100; _s_oFont.PutString(_m_tmpRect1, false, (GetScore()/1000).toString());
      }
    }

    _s_oFont.SetColor(_WHITESTATUSCOLOR);
  }

  void _DrawAdditionalPlayerStatus(int i_iActivePlayer)
  {
    C_Player oPlayer = m_oPlayer;
    if(oPlayer==null) return;

    if( m_oCheckPList.length>0 ) {
      _s_oGraph.DrawImage2D(_m_oLapsTime, null, _MAINPLAYERSTATUSPOS.x, _MAINPLAYERSTATUSPOS.y);
      //draw race status (Lap)
      _m_tmpRect1.width = 0; _m_tmpRect1.height = 0;
      _m_tmpRect1.x = _MAINPLAYERSTATUSPOS.x+30; _m_tmpRect1.y = _MAINPLAYERSTATUSPOS.y+4;
      _s_oFont.PutString(_m_tmpRect1, false, oPlayer.m_iCurLap.toString()+"/"+m_iNumLapsToRace.toString());

      double dSec = _m_dTotalTime/1000;
      _m_tmpRect1.y = _MAINPLAYERSTATUSPOS.y+25;
      _s_oFont.PutString(_m_tmpRect1, false, dSec.toStringAsFixed(2));
    } else {
      if(m_oMap.MapType()==2) { //dogfight
        _m_tmpRect1.x = 0; _m_tmpRect1.y = 22;
        _m_tmpRect1.width = 112; _m_tmpRect1.height = 20;
        _s_oGraph.DrawImage2D(_m_oCargoFuel, _m_tmpRect1, _MAINPLAYERSTATUSPOS.x, _MAINPLAYERSTATUSPOS.y+22);
      } else {
        _s_oGraph.DrawImage2D(_m_oCargoFuel, null, _MAINPLAYERSTATUSPOS.x, _MAINPLAYERSTATUSPOS.y);
        //draw cargostatus
        Vector4 oCol = ((oPlayer.CargoNumInHold()>=MAXSPACEINHOLDUNITS) ||
          (oPlayer.CargoWeightInHold()>=MAXSPACEINHOLDWEIGHT)) ? _MAINPLAYERSTATUSCOLOR2 : _MAINPLAYERSTATUSCOLOR1;
        double dPercentUsed = oPlayer.CargoWeightInHold() / MAXSPACEINHOLDWEIGHT;
        int iWidth = (110*dPercentUsed).toInt();
        if(iWidth>0) {
          _m_tmpRect1.x = _MAINPLAYERSTATUSPOS.x+1; _m_tmpRect1.y = _MAINPLAYERSTATUSPOS.y+1;
          _m_tmpRect1.width = iWidth; _m_tmpRect1.height = 18;
          _s_oGraph.DrawRectangle2D(_m_tmpRect1, oCol);
        }
        //draw fuelstatus
        oCol = _MAINPLAYERSTATUSCOLOR1;
        dPercentUsed = oPlayer.FuelPercentLeft();
        iWidth = (110*dPercentUsed).toInt();
        if(iWidth>0) {
          _m_tmpRect1.x = _MAINPLAYERSTATUSPOS.x+1; _m_tmpRect1.y = _MAINPLAYERSTATUSPOS.y+23;
          _m_tmpRect1.width = iWidth; _m_tmpRect1.height = 18;
          _s_oGraph.DrawRectangle2D(_m_tmpRect1, oCol);
        }
      }
      //draw num lifes
      int i, iNumShips = oPlayer.GetNumLives();
      if(iNumShips>0) {
        _m_tmpRect2.x = 0; _m_tmpRect2.y = 0;
        _m_tmpRect2.width = 48; _m_tmpRect2.height = 48;
        int y = (_MAINPLAYERSTATUSPOS.y-24)+(m_oMap.MapType()==2 ? 22:0);
        for(i=0; i<iNumShips; i++) {
          int x = _MAINPLAYERSTATUSPOS.x+i*12;
          _m_tmpRect1.x = x; _m_tmpRect1.y = y;
          _m_tmpRect1.width = 16; _m_tmpRect1.height = 16;
          _s_oGraph.DrawImage2D_Blend2(s_oShipImg, _m_tmpRect2, _m_tmpRect1, _STATUSCOLOR[i_iActivePlayer]);
        }
      }
    }
  }

}
