
REM this creates a jar file ready to be uploaded to the web server

REM the java project must be compiled before this script is run
REM follow the readme.txt

REM path setup

REM set the correct path here (where jar.exe is located)
SET java_path=C:\Program Files\Java\jdk1.8.0_112\bin
REM SET java_path=C:\Program Files (x86)\Java\jdk1.8.0_25\bin
SET dest_path=.\release_package

pushd "%~dp0"

REM create temp directories
md "%dest_path%"
md "%dest_path%\files"
md "%dest_path%\GalaxyPK"
md "%dest_path%\LoaderPK"
md "%dest_path%\SoundPK"
xcopy .\*.class "%dest_path%\"
xcopy .\files\* "%dest_path%\files\"
xcopy .\GalaxyPK\* "%dest_path%\GalaxyPK\"
xcopy .\LoaderPK\* "%dest_path%\LoaderPK\"
xcopy .\SoundPK\* "%dest_path%\SoundPK\"

REM create jar
"%java_path%\jar.exe" cvfm WebReplay.jar MANIFEST.MF -C "%dest_path%" LoaderStatus.class WebReplay.class LoaderPK GalaxyPK SoundPK files

REM remove temp directories
rd "%dest_path%" /S /Q

REM generate key
"%java_path%\keytool.exe" -genkey -alias galaxyv2 -dname "cn=galaxy, ou=galaxy, o=galaxy, c=SE" -keypass 11111111 -keystore galaxyv2.key -storepass 11111111
REM generate certificate
REM "%java_path%\keytool.exe" -selfcert -alias galaxyv2 -validity 1000000 -keypass 11111111 -keystore galaxyv2.key -storepass 11111111
REM export certificate
REM "%java_path%\keytool.exe" -certreq -alias galaxyv2 -file galaxyv2.cer -keypass 11111111 -keystore galaxyv2.key -storepass 11111111
REM sign the jar
"%java_path%\jarsigner.exe" -keystore galaxyv2.key -storepass 11111111 WebReplay.jar galaxyv2

del galaxyv2.key
REM del galaxyv2.cer

popd
