package GalaxyPK;

import java.awt.*;

public class C_Bullet extends C_Object
{
	private static final int BULLETLIFETIME = 8000;
	public static Image s_oBulletImg = null;
	private double m_dTotAlive;
	private boolean m_bNeverUpdated;
	private C_TileMap m_oMap;

	public C_Bullet(C_TileMap i_oMap, double i_dPosX, double i_dPosY, double i_dVelX, double i_dVelY, double i_dDirection, int i_iOwnerID)
	{
		m_iOwnerID = i_iOwnerID;
		
		m_oMap = i_oMap;
		m_stScreenArea = m_oMap.GetScreenRect();
		
		m_dPosX = i_dPosX; m_dPosY = i_dPosY;
		m_dVelX = i_dVelX; m_dVelY = i_dVelY;
		m_dDirection = i_dDirection;
		
		m_oImage = s_oBulletImg;
		m_stImageRect = null;
		m_dTotAlive = 0.0;

		m_bNeverUpdated = true; //used to skip 1st pos update
	}

	public boolean Update(double i_dTime)
	{
		if(!m_bNeverUpdated) {
			m_dTotAlive += i_dTime;
			if(m_dTotAlive > BULLETLIFETIME) return false;
			OUpdate(i_dTime);
		}
		m_bNeverUpdated = false;
		
		return !m_oMap.CheckCollision(this);
	}
	
	public void Draw()
	{
		Point p = m_oMap.GetPos();
		ODraw(s_oBulletImg, m_stImageRect/*null*/, p.x, p.y);
	}
	
	private int m_iBulletUniqeVal; //to identify this exact bullet
	public void SetUId(int i_iBulletUniqeVal) {m_iBulletUniqeVal = i_iBulletUniqeVal;};
	public int GetUId() {return m_iBulletUniqeVal;}
}
