package GalaxyPK;

import java.util.*;

public class C_BulletList
{
	private ArrayList<C_Bullet> m_oList;
	private int m_iGetPos = 0;
	
	public C_BulletList()
	{
		m_oList = new ArrayList<C_Bullet>();
	}
	
	C_Bullet GetNext(boolean i_bReset)
	{
		if(i_bReset) m_iGetPos = 0;
		if(m_iGetPos<(int)m_oList.size()) return m_oList.get(m_iGetPos++);
		else return null;
	}

	public void Add(C_Bullet i_oBullet)
	{
		m_oList.add(i_oBullet);
	}
	
	public void Remove(int i_iUID)
	{
		C_Bullet oBullet;
		int i, iCount = m_oList.size();
		
		for(i=0; i<iCount; i++) {
			oBullet = m_oList.get(i);
			
			if(oBullet.GetUId() == i_iUID) {
				if(i<m_iGetPos) m_iGetPos--;
				m_oList.remove(i);
				break;
			}
		}
	}

	public void Update(double i_dTime)
	{
		C_Bullet oBullet;
		int i, iCount = m_oList.size();
		
		for(i=0; i<iCount; i++) {
			oBullet = m_oList.get(i);
			
			if( !oBullet.Update(i_dTime) ) {
				//collision with map or full lifetime reached
				m_oList.remove(i);
				iCount--; i--;
			}
		}
	}

	public void Draw()
	{
		int i, iCount = m_oList.size();
		
		for(i=0; i<iCount; i++) {
			(m_oList.get(i)).Draw();
		}
	}

	public boolean CheckCollision(C_Object i_oObject)
	{
		C_Bullet oBullet;
		int i, iCount = m_oList.size();
		boolean bResult = false;
		int iBulletOwner;
		int iObjId = i_oObject.m_iOwnerID;
		
		if(iObjId>C_Object.COMPUTER_ENEMY_BASEID) iObjId = C_Object.COMPUTER_ENEMY_BASEID; //special case for computer enemies
		
		for(i=0; i<iCount; i++) {
			oBullet = m_oList.get(i);
			
			iBulletOwner = oBullet.m_iOwnerID;
			if(iBulletOwner>C_Object.COMPUTER_ENEMY_BASEID) iBulletOwner = C_Object.COMPUTER_ENEMY_BASEID; //owner is a computer enemy
			if(iBulletOwner != iObjId) {
				if(i_oObject.OCheckCollision(oBullet)) {
					m_oList.remove(i);
					bResult = true;
					break; //first found bullet hit wins
				}
			}
		}
		return bResult;
	}
}
