package GalaxyPK;

import java.awt.*;

/*
bool C_Door::CheckCollission(C_Object *i_pclObject, bool i_bIsBullet)
{
	int x, y, i;
	m_stScreenArea = *(m_pclMap->GetScreenRect());
	m_pclMap->GetPos(&x, &y);
	bool bResult = true;

	double xx = m_dPosX;
	double yy = m_dPosY;
	if(m_dDirection==270.0) {
		m_pstImageRect = &s_stVBaseRect[0];
		if(OCheckCollision(i_pclObject)) goto out;
		m_dPosX = xx; m_dPosY = yy+m_stInfo.iSize+36;
		m_pstImageRect = &s_stVBaseRect[1];
		if(OCheckCollision(i_pclObject)) goto out;

		int iSize = (m_stInfo.iSize-(int)m_dOpenPos)/2;
		S_Rect stRect = {0,0,6,iSize};

		m_dPosX = xx+23; m_dPosY = yy+36;
		if(ImageUtils::Compare(NULL, (int)m_dPosX, (int)m_dPosY, i_pclObject->m_pclImage,
			(int)i_pclObject->m_dPosX, (int)i_pclObject->m_dPosY, &stRect, i_pclObject->m_pstImageRect)) goto out;
		m_dPosX = xx+23; m_dPosY = yy+m_stInfo.iSize+36-iSize;
		if(ImageUtils::Compare(NULL, (int)m_dPosX, (int)m_dPosY, i_pclObject->m_pclImage,
			(int)i_pclObject->m_dPosX, (int)i_pclObject->m_dPosY, &stRect, i_pclObject->m_pstImageRect)) goto out;
	} else {
		m_pstImageRect = &s_stHBaseRect[0];
		if(OCheckCollision(i_pclObject)) goto out;
		m_dPosX = xx+m_stInfo.iSize+36; m_dPosY = yy;
		m_pstImageRect = &s_stHBaseRect[1];
		if(OCheckCollision(i_pclObject)) goto out;

		int iSize = (m_stInfo.iSize-(int)m_dOpenPos)/2;
		S_Rect stRect = {0,0,iSize,6};

		m_dPosX = xx+36; m_dPosY = yy+23;
		if(ImageUtils::Compare(NULL, (int)m_dPosX, (int)m_dPosY, i_pclObject->m_pclImage,
			(int)i_pclObject->m_dPosX, (int)i_pclObject->m_dPosY, &stRect, i_pclObject->m_pstImageRect)) goto out;
		m_dPosX = xx+m_stInfo.iSize+36-iSize; m_dPosY = yy+23;
		if(ImageUtils::Compare(NULL, (int)m_dPosX, (int)m_dPosY, i_pclObject->m_pclImage,
			(int)i_pclObject->m_dPosX, (int)i_pclObject->m_dPosY, &stRect, i_pclObject->m_pstImageRect)) goto out;
	}
	m_pstImageRect = &s_stButtonRect[0];
	for(i=0; i<m_stInfo.iNumButtons; i++) {
		m_dPosX = m_stInfo.stButtonPos[i].x;
		m_dPosY = m_stInfo.stButtonPos[i].y;
		if(OCheckCollision(i_pclObject)) {
			if(i_bIsBullet && m_bMaster) {
				m_dStateTime = 0;
				m_bIsOpening = !m_bIsOpening; //toggle
				SendDoorAction(m_bIsOpening);
			}
			goto out;
		}
	}
	bResult = false;

out:
	m_dPosX = xx;
	m_dPosY = yy;
	return bResult;
}
*/

class S_DoorInfo
{
	int iSize;
	boolean bHorizontal;
	int iOpenedForTime;
	int iClosedForTime;
	int iOpeningSpeed; //pixels/sec
	int iClosingSpeed; //pixels/sec
	int iNumButtons; //0 -> interval opening
	Point stButtonPos[];
	Point astWayPoints[];
}

public class C_Door extends C_Object
{
	//static
	private static final Rectangle s_stVBaseRect[] = {new Rectangle(0,0,52,36),new Rectangle(0,36,52,36)};
	private static final Rectangle s_stVDoorRect[] = {new Rectangle(23,0,6,6),new Rectangle(23,6,6,24),new Rectangle(23,30,6,6)};
	private static final Rectangle s_stHBaseRect[] = {new Rectangle(52,20,36,52),new Rectangle(88,20,36,52)};
	private static final Rectangle s_stHDoorRect[] = {new Rectangle(52,43,6,6),new Rectangle(58,43,24,6),new Rectangle(82,43,6,6)};
	private static final Rectangle s_stButtonRect[] = {new Rectangle(52,0,23,19),new Rectangle(75,0,23,19)};

	//common
	protected C_TileMap    m_oMap;
	protected C_Replay     m_oReplay;
//	protected C_BulletList m_oBulletList;

	//animation
	boolean m_bIsOpening;
	double m_dOpenPos;
	double m_dStateTime;

	//behavior
	S_DoorInfo m_stInfo;

	//images
	private static Image s_oDoorImg;
	public static void InitImages(Image i_oDoorImg)
	{
		s_oDoorImg = i_oDoorImg;
	}
	
	public C_Door(C_TileMap i_oMap, C_Replay i_oReplay, int i_iX, int i_iY, S_DoorInfo i_stDoorInfo, int i_iID)
	{
		super();
		
		m_iOwnerID = i_iID;
		m_oMap = i_oMap;
		m_oReplay = i_oReplay;
		m_stScreenArea = m_oMap.GetScreenRect();
		
		m_iOwnerID = i_iID;
		m_dPosX = i_iX;
		m_dPosY = i_iY;
		m_dVelX = m_dVelY = m_dAcceleration = 0.0;
		m_stInfo = i_stDoorInfo;
		m_dDirection = m_stInfo.bHorizontal ? 270.0 : 0.0;

		m_oImage = s_oDoorImg;
		m_stImageRect = null;

		m_bIsOpening = false;
		m_dOpenPos = 0.0;
		m_dStateTime = 0.0;

	}

	public void Update(double i_dTime)
	{
		S_ReplayAction stAction;
		while( (stAction = m_oReplay.Get(m_iOwnerID, 1))!=null ) {
			if((stAction.stMsg1.iMsg & S_NetMsg1.N_MSG1_KEYCHANGE)!=0) {
				m_dStateTime = 0;
				m_bIsOpening = stAction.stMsg1.iReason_Hits_Door!=0;
			}
		}

		if(m_bIsOpening) {
			m_dOpenPos += i_dTime*(m_stInfo.iOpeningSpeed*0.001);
			if(m_dOpenPos>=m_stInfo.iSize) {
				m_dOpenPos = m_stInfo.iSize;
				m_dStateTime += i_dTime;
			}
		} else {
			m_dOpenPos -= i_dTime*(m_stInfo.iClosingSpeed*0.001);
			if(m_dOpenPos<=0) {
				m_dOpenPos = 0;
				m_dStateTime += i_dTime;
			}
		}
	}

	public void Draw()
	{
		int i;
		Point p = m_oMap.GetPos();

		double xx = m_dPosX;
		double yy = m_dPosY;
		Rectangle stRect;
		if(m_dDirection==270.0) {
			ODraw(m_oImage, s_stVBaseRect[0], p.x, p.y);
			m_dPosX = xx; m_dPosY = yy+m_stInfo.iSize+36;
			ODraw(m_oImage, s_stVBaseRect[1], p.x, p.y);

			stRect = s_stVDoorRect[1];
			int iSize = (m_stInfo.iSize-(int)m_dOpenPos)/2;
			int iPos = -6;
			while(iPos<iSize-6) {
				if(iPos+24>=iSize-6) stRect.height=(iSize-6)-iPos;
				m_dPosX = xx+23; m_dPosY = yy+36+iPos;
				ODraw(m_oImage, stRect, p.x, p.y);
				m_dPosX = xx+23; m_dPosY = yy+m_stInfo.iSize+36-iPos-stRect.height;
				ODraw(m_oImage, stRect, p.x, p.y);
				iPos+=stRect.height;
			}

			m_dPosX = xx+23; m_dPosY = yy+36+iPos;
			ODraw(m_oImage, s_stVDoorRect[2], p.x, p.y);
			m_dPosX = xx+23; m_dPosY = yy+m_stInfo.iSize+36-iPos-6;
			ODraw(m_oImage, s_stVDoorRect[0], p.x, p.y);
		} else {
			ODraw(m_oImage, s_stHBaseRect[0], p.x, p.y);
			m_dPosX = xx+m_stInfo.iSize+36; m_dPosY = yy;
			ODraw(m_oImage, s_stHBaseRect[1], p.x, p.y);

			stRect = s_stHDoorRect[1];
			int iSize = (m_stInfo.iSize-(int)m_dOpenPos)/2;
			int iPos = -6;
			while(iPos<iSize-6) {
				if(iPos+24>=iSize-6) stRect.width=(iSize-6)-iPos;
				m_dPosX = xx+36+iPos; m_dPosY = yy+23;
				ODraw(m_oImage, stRect, p.x, p.y);
				m_dPosX = xx+m_stInfo.iSize+36-iPos-stRect.width; m_dPosY = yy+23;
				ODraw(m_oImage, stRect, p.x, p.y);
				iPos+=stRect.width;
			}

			m_dPosX = xx+36+iPos; m_dPosY = yy+23;
			ODraw(m_oImage, s_stHDoorRect[2], p.x, p.y);
			m_dPosX = xx+m_stInfo.iSize+36-iPos-6; m_dPosY = yy+23;
			ODraw(m_oImage, s_stHDoorRect[0], p.x, p.y);
		}
		for(i=0; i<m_stInfo.iNumButtons; i++) {
			m_dPosX = m_stInfo.stButtonPos[i].x;
			m_dPosY = m_stInfo.stButtonPos[i].y;
			ODraw(m_oImage, s_stButtonRect[m_bIsOpening ? 1 : 0], p.x, p.y);
		}

		m_dPosX = xx;
		m_dPosY = yy;
	}

	boolean CheckCollission(C_Object i_oObject)
	{
		int i;
		m_stScreenArea = m_oMap.GetScreenRect();
		boolean bResult = true;
		boolean bAssignResult = true;

		double xx = m_dPosX;
		double yy = m_dPosY;
		do {
			if(m_dDirection==270.0) {
				m_stImageRect = s_stVBaseRect[0];
				if(OCheckCollision(i_oObject)) break;
				m_dPosX = xx; m_dPosY = yy+m_stInfo.iSize+36;
				m_stImageRect = s_stVBaseRect[1];
				if(OCheckCollision(i_oObject)) break;
	
				int iSize = (m_stInfo.iSize-(int)m_dOpenPos)/2;
				Rectangle stRect = new Rectangle(0,0,6,iSize);
	
				m_dPosX = xx+23; m_dPosY = yy+36;
				if(C_Collision.CompareBuffered(null, (int)m_dPosX, (int)m_dPosY, i_oObject.m_oImage,
					(int)i_oObject.m_dPosX, (int)i_oObject.m_dPosY, stRect, i_oObject.m_stImageRect)) break;
				m_dPosX = xx+23; m_dPosY = yy+m_stInfo.iSize+36-iSize;
				if(C_Collision.CompareBuffered(null, (int)m_dPosX, (int)m_dPosY, i_oObject.m_oImage,
					(int)i_oObject.m_dPosX, (int)i_oObject.m_dPosY, stRect, i_oObject.m_stImageRect)) break;
			} else {
				m_stImageRect = s_stHBaseRect[0];
				if(OCheckCollision(i_oObject)) break;
				m_dPosX = xx+m_stInfo.iSize+36; m_dPosY = yy;
				m_stImageRect = s_stHBaseRect[1];
				if(OCheckCollision(i_oObject)) break;
	
				int iSize = (m_stInfo.iSize-(int)m_dOpenPos)/2;
				Rectangle stRect = new Rectangle(0,0,iSize,6);
	
				m_dPosX = xx+36; m_dPosY = yy+23;
				
				if(C_Collision.CompareBuffered(null, (int)m_dPosX, (int)m_dPosY, i_oObject.m_oImage,
					(int)i_oObject.m_dPosX, (int)i_oObject.m_dPosY, stRect, i_oObject.m_stImageRect)) break;
				m_dPosX = xx+m_stInfo.iSize+36-iSize; m_dPosY = yy+23;
				if(C_Collision.CompareBuffered(null, (int)m_dPosX, (int)m_dPosY, i_oObject.m_oImage,
					(int)i_oObject.m_dPosX, (int)i_oObject.m_dPosY, stRect, i_oObject.m_stImageRect)) break;
			}
			m_stImageRect = s_stButtonRect[0];
			for(i=0; i<m_stInfo.iNumButtons; i++) {
				m_dPosX = m_stInfo.stButtonPos[i].x;
				m_dPosY = m_stInfo.stButtonPos[i].y;
				if(OCheckCollision(i_oObject)) {
					bAssignResult = false;
					break;
				}
			}
			if(bAssignResult) bResult = false;
		} while(false);

		m_dPosX = xx;
		m_dPosY = yy;
		return bResult;
	}
	
}
