package GalaxyPK;

import java.io.*;

public class C_LineReader
{
	private FilterInputStream  s;
	
	public  C_LineReader(InputStream oIS)
	{
		s = new DataInputStream(oIS);
	}
	
	public String readLine() throws IOException
	{
		char[]  buffer = new char[200];
		int     offset = 0;
		int     thisByte;
		boolean bEOF = false;
		
		try {
loop:		while(offset < buffer.length) {
				thisByte = s.read();
				switch(thisByte) {
				case -1: 
					bEOF = true;
					break loop;
				//^char 255 (-1) does not exist normally in the read text files
				case '\n':
					break loop;
				case '\r':
					int  nextByte = s.read();
					
					if(nextByte!='\n' && nextByte!=-1) {
						if (!(s instanceof PushbackInputStream)) {
							s = new PushbackInputStream(s);
						}
						((PushbackInputStream)s).unread((byte)nextByte);
					}
					break loop;
				default: buffer[offset++] = (char)thisByte;
					break;
				}
			}
		} catch (EOFException e) { //never happens, rely on the -1 case above
			bEOF = true;
		}
		if(bEOF && offset==0) return null;
		return String.copyValueOf(buffer, 0, offset);
	}

}
