package GalaxyPK;

import java.awt.*;
import SoundPK.*;

public abstract class C_PlayerBase extends C_Object
{
	public static final double HEARING_RANGE = 2200.0; //maxdistance sound is played at all
	public static final double PANNING_RANGE = 500.0; //maxdistance sound is played in both speakers
	public static final int EXPLOSIONSIZE = 56;
	//explosion gfx
	private static Image s_oExplosionImg;
	private static Rectangle s_astExplosionRects[] = new Rectangle[16];
	private double  m_dFrameNr;
	protected C_Sound m_oSound;
	protected double m_dVol, m_dPan;

	public static void InitExplosionImage(Image i_oExplosionImg)
	{
		int i, j;
		
		s_oExplosionImg = i_oExplosionImg;
		for(j=0; j<2; j++) {
			for(i=0; i<8; i++) {
				s_astExplosionRects[j*8+i] = new Rectangle(i*EXPLOSIONSIZE, j*EXPLOSIONSIZE, EXPLOSIONSIZE, EXPLOSIONSIZE);
			}
		}
	}

	public C_PlayerBase()
	{
		super();

		m_oSound = C_Sound.GetSoundObject();
		m_dFrameNr = 0.0;
		
		m_dVol = 50.0;
		m_dPan = 0.0;
	}
	
	protected static C_Object s_oListner = null;
	public static void SetListner(C_Object i_oListner)
	{
		s_oListner = i_oListner;
	}
	
	public boolean UpdateExplosion(double i_dTime)
	{
		if(i_dTime==0.0) m_dFrameNr = 0; //reset
		m_dFrameNr += i_dTime*0.018; //18 fps anim

		boolean bReady = (m_dFrameNr > 15);
		return bReady;
	}
	
	public void DrawExplosion(int i_iX, int i_iY)
	{
		if(m_dFrameNr<16.0) {
			Rectangle stRect = s_astExplosionRects[(int)m_dFrameNr];
			
			//center explosion
			Point stSize = GetSize();
			i_iX -= (stSize.x/2) - (EXPLOSIONSIZE/2);
			i_iY -= (stSize.y/2) - (EXPLOSIONSIZE/2);
			
			ODraw(s_oExplosionImg, stRect, i_iX, i_iY);
		}
	}

	public void CalcSoundVolPan(C_Object i_oListner)
	{
		Point stCenter = i_oListner.GetCenterPos();
		Point stOwnCenter = GetCenterPos();
		
		double dDistX = stOwnCenter.x - stCenter.x;
		double dDistY = stOwnCenter.y - stCenter.y;
		double dDist = Math.sqrt(dDistX*dDistX + dDistY*dDistY);
		
		//volume
		m_dVol = 100.0 - dDist/(HEARING_RANGE/100.0);
		if(m_dVol<0) m_dVol = 0;
		//panning
		m_dPan = dDistX/(PANNING_RANGE/1.0);
		//if(m_dPan > 1.0) dPan = 1.0;
		//else if(m_dPan < -1.0) dPan = -1.0;
	}
	
	void GetCommonInfo(S_NetMsg1 i_stMsg1)
	{
		m_dAcceleration = i_stMsg1.fAcceleration;
		m_dDirection = i_stMsg1.fDirection;
		m_dPosX = i_stMsg1.fPosX;
		m_dPosY = i_stMsg1.fPosY;
		m_dVelX = i_stMsg1.fVelX;
		m_dVelY = i_stMsg1.fVelY;

		m_dGravityY = i_stMsg1.fGravityY;
		m_bCanCollide = i_stMsg1.bCanCollide;
	}

}
