import java.awt.*;

public class LoaderStatus
{
	private int m_iProgress               = 0;
	private Graphics m_oGrap              = null;
	
	private int m_iYPosition              = 0;
	private int m_iWidth                  = 0;
	private int m_iHeight                 = 0;

	private int m_iXProgress              = 0;
	private int m_iBarWidth               = 0;
	private static final int m_iBarHeight = 40;
	
	
	public LoaderStatus(int w, int h, Graphics i_oBackBuffer, int i_iBarLength)
	{
		m_iHeight     = h;
		m_iWidth      = w;
		m_iBarWidth   = m_iWidth;
		m_iYPosition  = m_iHeight/2 - m_iBarHeight / 2;
		
		m_iXProgress = m_iWidth / i_iBarLength;
		
		m_oGrap = i_oBackBuffer;
	}

	public void IncProgress()
	{
		m_iProgress++;
		Draw();
	}

	private void Draw()
	{
		m_oGrap.setColor(Color.DARK_GRAY);
		m_oGrap.fillRect(0, m_iYPosition-20, m_iBarWidth, 20);
		m_oGrap.setColor(Color.LIGHT_GRAY);
		m_oGrap.drawString("GalaxtV2 replay viewer 1.0", 5, m_iYPosition-5);
		m_oGrap.fillRect(0, m_iYPosition, m_iBarWidth, m_iBarHeight);		
		m_oGrap.setColor(Color.RED);
		m_oGrap.fillRect(0, m_iYPosition+2, m_iProgress*m_iXProgress+m_iXProgress, m_iBarHeight-4);
	}
}
