
part of web_replay2;


class C_Viewport
{
  List<int> m_aiPlayerStartPosX = new List<int>(8), m_aiPlayerStartPosY = new List<int>(8);
  List<C_LandingZone> m_oLandingZList = new List<C_LandingZone>();
  List<C_CheckPoint> m_oCheckPList = new List<C_CheckPoint>();
  List<C_ComputerEnemy> m_oCompEnemyList = new List<C_ComputerEnemy>();
  List<C_Door> m_oDoorList = new List<C_Door>();
  C_BulletList m_oBulletList = new C_BulletList();
  List<C_Player> m_oPlayers;
  C_TileMap      m_oMap;
  C_Replay       m_oReplay;
  int            m_iNumLapsToRace;

  int _m_iReplayFollowPlayer;
  int _m_iReplayOldCP;

  static C_Font _s_oFont;
  static C_Graph _s_oGraph;

  static C_Image _m_oCargoFuel;
  static C_Image _m_oLapsTime;
  static C_Image s_oShipImg;

  static final int MAXSPACEINHOLDUNITS = 3;
  static final int MAXSPACEINHOLDWEIGHT = 50;

  List<bool> _m_bTimeCounting = new List<bool>(8);
  List<double> _m_dTotalTime = new List<double>(8);
  double _m_dTotalTimePlayed;

  static void InitImagesAndStuff(C_Graph i_oBackBuffer, C_Image i_oShipImg,
    C_Image i_oExplosionImg, C_Image i_oBulletImg, C_Image i_oLandingZoneImg, C_Image i_oCpImg,
    C_Image i_oE0, C_Image i_oE1, C_Image i_oE2, C_Image i_oE3, C_Image i_oE4,
    C_Image i_oE5, C_Image i_oE6, C_Image i_oE7, C_Image i_oDoorImg,
    C_Image i_oCargoFuel, C_Image i_oLapsTime, C_Font i_oFont)
  {
    _s_oGraph = i_oBackBuffer;
    s_oShipImg = i_oShipImg;
    C_PlayerBase.InitExplosionImage(i_oExplosionImg);
    C_Bullet.s_oBulletImg = i_oBulletImg;
    C_LandingZone.InitImage(i_oLandingZoneImg);
    C_ComputerEnemy.InitImages(i_oE0, i_oE1, i_oE2, i_oE3, i_oE4, i_oE5, i_oE6, i_oE7);
    C_CheckPoint.s_oCpImg = i_oCpImg;
    C_CheckPoint.s_oFont = i_oFont;
    C_Door.InitImages(i_oDoorImg);

    _s_oFont = i_oFont;

    _m_oCargoFuel = i_oCargoFuel;
    _m_oLapsTime = i_oLapsTime;
  }

  void InitPlayersAndSetMap(C_TileMap i_oMap)
  {
    m_oMap = i_oMap;
    m_oPlayers = new List<C_Player>(8);
    S_ReplayHeader stInfo = m_oReplay.GetGameInfo();
    for(int i=0; i<8; i++) {
      _m_bTimeCounting[i] = false;
      _m_dTotalTime[i] = 0.0;
      if(stInfo.szPlayerName[i].length>0) {
        m_oPlayers[i] = new C_Player(i, stInfo.szPlayerName[i], s_oShipImg, _STATUSCOLOR[i], m_oReplay, m_oMap, m_oBulletList, m_aiPlayerStartPosX[i], m_aiPlayerStartPosY[i], stInfo.iLevelType==3 ? -1 : 5);
      } else m_oPlayers[i] = null;
    }
    _m_iReplayFollowPlayer = 0;
    _m_iReplayOldCP = 0;
    ReplayFollow(false);

    _m_dTotalTimePlayed = 0.0;
  }

  //changes the draw area
  // the whole window size is now used for drawing
  void SetSize(int i_iWidth, int i_iHeight)
  {
    int i, w, h;
    S_Rect stNewRect = new S_Rect(0, 0, i_iWidth, i_iHeight);
    w = m_oMap._m_iWidth*m_oMap._m_iTileSize;
    h = m_oMap._m_iHeight*m_oMap._m_iTileSize;
    if(i_iWidth>w) {
      stNewRect.x = (i_iWidth-w)~/2;
      stNewRect.width = w;
    }
    if(i_iHeight>h) {
      stNewRect.y = (i_iHeight-h)~/2;
      stNewRect.height = h;
    }
    _MAINPLAYERSTATUSPOS = new Point(stNewRect.x+4,     -50+stNewRect.y+stNewRect.height);
    _STATUSPOS[0] = new Point(stNewRect.x+120+2,    -84+stNewRect.y+stNewRect.height);
    _STATUSPOS[1] = new Point(stNewRect.x+120+2+228,-84+stNewRect.y+stNewRect.height);
    _STATUSPOS[2] = new Point(stNewRect.x+120+2,    -64+stNewRect.y+stNewRect.height);
    _STATUSPOS[3] = new Point(stNewRect.x+120+2+228,-64+stNewRect.y+stNewRect.height);
    _STATUSPOS[4] = new Point(stNewRect.x+120+2,    -44+stNewRect.y+stNewRect.height);
    _STATUSPOS[5] = new Point(stNewRect.x+120+2+228,-44+stNewRect.y+stNewRect.height);
    _STATUSPOS[6] = new Point(stNewRect.x+120+2,    -24+stNewRect.y+stNewRect.height);
    _STATUSPOS[7] = new Point(stNewRect.x+120+2+228,-24+stNewRect.y+stNewRect.height);

    m_oMap.SetScreenRect(stNewRect);
  }

  void ReplayFollow(bool i_bNext)
  {
    int i, iSize;
    int iOldPlayer = _m_iReplayFollowPlayer;
    if(!i_bNext && m_oPlayers[_m_iReplayFollowPlayer]==null) i_bNext = true;
    if(i_bNext) {
      for(i=0; i<8; i++) {
        _m_iReplayFollowPlayer++;
        if(_m_iReplayFollowPlayer>7) _m_iReplayFollowPlayer=0;
        if(m_oPlayers[_m_iReplayFollowPlayer]!=null) break;
      }
    }

    C_Player oPlayer = m_oPlayers[_m_iReplayFollowPlayer];
    C_PlayerBase.SetListner(oPlayer);
    if(oPlayer!=null) {
      S_Rect stRect = m_oMap.GetScreenRect();
      int iPosX = oPlayer.GetCenterPosX() - (stRect.width~/2);
      int iPosY = oPlayer.GetCenterPosY() - (stRect.height~/2);
      m_oMap.MoveAbsolute(iPosX, iPosY);

      iSize = m_oCheckPList.length;
      if(iSize>0) {
        for(i=0; i<iSize; i++) {
          if(i!=oPlayer.m_iCurCP) m_oCheckPList[i].SetBlinkState(false);
        }
        if(oPlayer.m_iCurLap < m_iNumLapsToRace)
          m_oCheckPList[oPlayer.m_iCurCP].SetBlinkState(true);
        if(iOldPlayer == _m_iReplayFollowPlayer) {
          if(_m_iReplayOldCP!=oPlayer.m_iCurCP) {
            if(oPlayer.m_iCurLap < m_iNumLapsToRace) C_Sound.s_oSound.PlaySound(5, 1.0, 0.0, false);
            else C_Sound.s_oSound.PlaySound(6, 1.0, 0.0, false);
          }
        }
        _m_iReplayOldCP = oPlayer.m_iCurCP;
      }
    }

  }

  void SoundOn(bool i_bSound)
  {
    for(int i=0; i<8; i++) {
      if(m_oPlayers[i]!=null) m_oPlayers[i].SoundOn(i_bSound);
    }
  }

  String GetTimeAsString(double dTime)
  {
    int iSec = dTime ~/ 1000;
    int i100 = (dTime~/10) % 100;
    String szString = iSec.toString();
    szString += ".";
    if(i100 <10) szString += "0";
    szString += i100.toString();
    return szString;
  }

  int Update(double i_dTime)
  {
    int i, iSize;
    int iGameStatus = 0;

    _m_dTotalTimePlayed += i_dTime;
    
    //update fade out (removes click/pop in looping sounds that are stopped)
    C_Player.UpdateFadeOut(i_dTime);

    //update doors
    iSize = m_oDoorList.length;
    for(i=0; i<iSize; i++) {
      C_Door oDoor = m_oDoorList[i];
      oDoor.Update(i_dTime);
    }

    //update bullets
    m_oBulletList.Update(i_dTime);
    C_Bullet oBullet = m_oBulletList.GetNext(true);
    while(oBullet!=null) {
      for(i=0; i<iSize; i++) {
        C_Door oDoor = m_oDoorList[i];
        if(oDoor.CheckCollission(oBullet)) {
          m_oBulletList.Remove(oBullet.GetUId());
        }
      }
      oBullet = m_oBulletList.GetNext(false);
    }

    //update player movements
    for(i=0; i<8; i++) {
      if(m_oPlayers[i]!=null) m_oPlayers[i].Update(i_dTime);

      if(_m_bTimeCounting[i]) _m_dTotalTime[i] += i_dTime;
    }

    //update landingzones
    iSize = m_oLandingZList.length;
    for(i=0; i<iSize; i++) {
      C_LandingZone oZone = m_oLandingZList[i];
      oZone.Update(i_dTime);
      for(int j=0; j<8; j++) {
        if(m_oPlayers[j]!=null) oZone.UpdateFuel(m_oPlayers[j], i_dTime);
      }
    }

    //update enemies
    iSize = m_oCompEnemyList.length;
    for(i=0; i<iSize; i++) {
      C_ComputerEnemy oEnemy = m_oCompEnemyList[i];
      int iResult = oEnemy.Update(i_dTime);
      if(iResult==-2) { //remove enemy
        m_oCompEnemyList.removeAt(i);
        i--; iSize--; //compensate for remove to be able to keep on looping
      }
    }

    //update checkpoints
    iSize = m_oCheckPList.length;
    if(iSize>0) { //there are checkpoints (racemap)
      C_CheckPoint oCP;
      for(i=0; i<iSize; i++) {
        oCP = m_oCheckPList[i];
        oCP.Update(i_dTime);
      }
      for(int i=0; i<8; i++) {
        if(m_oPlayers[i]!=null) {
          //trigger start time counter
          if(m_oPlayers[i].m_iCurCP==1) _m_bTimeCounting[i] = true;
        }
      }
    }

    //set new map position
    ReplayFollow(false);

    return iGameStatus;
  }

  void HandleCargoReply(S_NetMsg2 i_stMsg2)
  {
    int i, iSize = m_oLandingZList.length;
    for(i=0; i<iSize; i++) {
      C_LandingZone oZone = m_oLandingZList[i];
      if(i_stMsg2.iInt1 == oZone.m_iOwnerID) {
        /*int iCargo =*/ oZone.PopCargo();
        //TODO cargo load sound should be played but the player id does not exist in the message
        // also there is no good way of playing the unload sound
      }
    }
    //i_stMsg2.iCargoNum //should not need to be used...
  }

  void HandleCargoRespawn(S_NetMsg2 i_stMsg2)
  {
    int i, iSize = m_oLandingZList.length;
    for(i=0; i<iSize; i++) {
      C_LandingZone oZone = m_oLandingZList[i];
      if(i_stMsg2.iInt1 == oZone.m_iOwnerID) {
        oZone.PushCargo(i_stMsg2.iInt3);
      }
    }
    //i_stMsg2.iCargoNum //should not need to be used...
  }

  void HandleLifeRequest(S_NetMsg2 i_stMsg2)
  {
    int i, iSize = m_oLandingZList.length;
    for(i=0; i<iSize; i++) {
      C_LandingZone oZone = m_oLandingZList[i];
      if(i_stMsg2.iInt1 == oZone.m_iOwnerID) {
        oZone.TakeExtraLife();
        if(i_stMsg2.iInt3==1) {
          if(m_oPlayers[i_stMsg2.iPlayerId]!=null) m_oPlayers[i_stMsg2.iPlayerId].AddLife();
        }
      }
    }
  }

  void Draw()
  {
    int i, iSize;

    //draw map
    m_oMap.Draw();

    //draw doors
    iSize = m_oDoorList.length;
    for(i=0; i<iSize; i++) {
      C_Door oDoor = m_oDoorList[i];
      oDoor.Draw();
    }

    //draw checkpoints
    iSize = m_oCheckPList.length;
    for(i=0; i<iSize; i++) {
      C_CheckPoint oCP = m_oCheckPList[i];
      oCP.Draw();
    }

    //draw landingzones
    iSize = m_oLandingZList.length;
    for(i=0; i<iSize; i++) {
      C_LandingZone oZone = m_oLandingZList[i];
      oZone.Draw();
    }

    //draw enemies
    iSize = m_oCompEnemyList.length;
    for(i=0; i<iSize; i++) {
      C_ComputerEnemy oEnemy = m_oCompEnemyList[i];
      oEnemy.Draw();
    }

    //draw players
    for(i=0; i<8; i++) {
      if(m_oPlayers[i]!=null) m_oPlayers[i].Draw();
    }

    //draw bullets
    m_oBulletList.Draw();

    //draw info
    _DrawAllPlayersStatus();

    _DrawAdditionalPlayerStatus(_m_iReplayFollowPlayer);
  }

  int GetScore(int i_iPlayerIndex) //not valid for race
  {
    int iScore = 0;
    C_Player oShip = m_oPlayers[i_iPlayerIndex];
    if(oShip!=null) {
      int iLifes = oShip.GetNumLives();
      if(iLifes<0) iLifes = 0;
      iScore = (oShip.m_iScore+iLifes*50)*1000;
      if(m_oMap.MapType()==1) { //mission
        if(m_oMap.MapType()==4) { //mission coop
          int iMaxMapPlayers = m_oMap.MaxPlayers();
          int iLifesLost = 0;
          iScore = 0;
          for(int i=0; i<8; i++) {
            C_Player oShip2 = m_oPlayers[i];
            if(oShip2!=null) {
              iLifes = oShip2.GetNumLives();
              if(iLifes<0) iLifes = 0;
              iLifesLost += (5-iLifes);
              iScore += oShip2.m_iScore;
            }
          }
          iScore += (iMaxMapPlayers-iLifesLost)*50*1000;
        }
        iScore -= (_m_dTotalTimePlayed~/2); //long time is bad in mission
      }
    }
    return iScore;
  }

  static final List<List<int>> _PLAYERSPOS = [ //[numplayers][player_index] used in STATUSPOS
    [6,0,0,0,0,0,0,0],
    [6,7,0,0,0,0,0,0],
    [4,6,7,0,0,0,0,0],
    [4,5,6,7,0,0,0,0],
    [2,4,5,6,7,0,0,0],
    [2,3,4,5,6,7,0,0],
    [0,2,3,4,5,6,7,0],
    [0,1,2,3,4,5,6,7]
  ];
  static List<Point> _STATUSPOS = [
    new Point(120+2,    -84+600),
    new Point(120+2+228,-84+600),
    new Point(120+2,    -64+600),
    new Point(120+2+228,-64+600),
    new Point(120+2,    -44+600),
    new Point(120+2+228,-44+600),
    new Point(120+2,    -24+600),
    new Point(120+2+228,-24+600)
  ];
  static List<Vector4> _STATUSCOLOR = [
    new Vector4(0xAD/255.0,0x16/255.0,0x16/255.0,1.0),
    new Vector4(0x46/255.0,0xB3/255.0,0x9E/255.0,1.0),
    new Vector4(0x16/255.0,0xAE/255.0,0x16/255.0,1.0),
    new Vector4(0x19/255.0,0x4F/255.0,0xBF/255.0,1.0),
    new Vector4(0xC4/255.0,0xAF/255.0,0x46/255.0,1.0),
    new Vector4(0x9E/255.0,0x16/255.0,0x98/255.0,1.0),
    new Vector4(0xCD/255.0,0xCD/255.0,0xCD/255.0,1.0),
    new Vector4(0x93/255.0,0x9F/255.0,0x16/255.0,1.0)
  ];
  static Point _MAINPLAYERSTATUSPOS = new Point(4, -50+600);
  static Vector4 _MAINPLAYERSTATUSCOLOR1 = new Vector4(0x09/255.0, 0x6f/255.0, 0xcc/255.0, 1.0);
  static Vector4 _MAINPLAYERSTATUSCOLOR2 = new Vector4(0xcc/255.0, 0x0a/255.0, 0x2e/255.0, 1.0);

  static Vector4 _GREYSTATUSCOLOR = new Vector4(0.50, 0.50, 0.50, 0.60);
  static Vector4 _WHITESTATUSCOLOR = new Vector4(1.00, 1.00, 1.00, 1.00);
  S_Rect _m_tmpRect1 = new S_Rect(0, 0, 0, 0);
  S_Rect _m_tmpRect2 = new S_Rect(0, 0, 0, 0);
  void _DrawAllPlayersStatus()
  {
    int i, j, k = 0;

    int iNumPlayers = 0;
    for(i=0; i<8; i++) {
      if(m_oPlayers[i]!=null) iNumPlayers++;
    }

    int iCurPos = 0;
    _m_tmpRect2.x = 0; _m_tmpRect2.y = 0; _m_tmpRect2.width = 48; _m_tmpRect2.height = 48;
    for(i=0; i<8; i++) {
      C_Player oShip = m_oPlayers[i];
      if(oShip!=null) {
        int iNumShips = oShip.GetNumLives();
        if(i!=_m_iReplayFollowPlayer) {
          for(j=0; j<iNumShips; j++) {
            _m_tmpRect1.x = 4+j*12;
            _m_tmpRect1.y = 0+k*16;
            _m_tmpRect1.width = 4+j*12+16;
            _m_tmpRect1.height = 0+k*16+16;
            _s_oGraph.DrawImage2D_Blend2(s_oShipImg, _m_tmpRect2, _m_tmpRect1, _STATUSCOLOR[i]);
          }
          k++;
        }

        int iPos = _PLAYERSPOS[iNumPlayers-1][iCurPos];
        _m_tmpRect1.x = _STATUSPOS[iPos].x;
        _m_tmpRect1.y = _STATUSPOS[iPos].y;
        _m_tmpRect1.width = 224;
        _m_tmpRect1.height = 16;
        if( m_oCheckPList.length>0 ) _m_tmpRect1.x -= 48;
        _s_oGraph.DrawRectangle2D(_m_tmpRect1, _GREYSTATUSCOLOR);

        _s_oFont.SetColor(_STATUSCOLOR[i]);
        _m_tmpRect1.width = 0;
        _m_tmpRect1.height = 0;
        if( m_oCheckPList.length>0 ) {
          //race:             name, best lap time, current lap and cp
          double dBestLap = oShip.m_dBestLapTime>999000.0 ? 999000.0 : oShip.m_dBestLapTime;
          _m_tmpRect1.x += 2;   _s_oFont.PutString(_m_tmpRect1, false, oShip.m_szName);
          _m_tmpRect1.x += 100; _s_oFont.PutString(_m_tmpRect1, false, GetTimeAsString(dBestLap));
          _m_tmpRect1.x += 62;  _s_oFont.PutString(_m_tmpRect1, false,
            "Lap "+oShip.m_iCurLap.toString()+"["+oShip.m_iCurCP.toString()+"]");
        } else {
          //mission/dogfight: name, score
          _m_tmpRect1.x += 2;   _s_oFont.PutString(_m_tmpRect1, false, oShip.m_szName);
          _m_tmpRect1.x += 100; _s_oFont.PutString(_m_tmpRect1, false, (GetScore(i)/1000).toString());
        }
        iCurPos++;
      }
    }
    _s_oFont.SetColor(_WHITESTATUSCOLOR);
  }

  void _DrawAdditionalPlayerStatus(int i_iActivePlayer)
  {
    C_Player oPlayer = m_oPlayers[i_iActivePlayer];
    if(oPlayer==null) return;

    if( m_oCheckPList.length>0 ) {
      _s_oGraph.DrawImage2D(_m_oLapsTime, null, _MAINPLAYERSTATUSPOS.x, _MAINPLAYERSTATUSPOS.y);
      //draw race status (Lap)
      _m_tmpRect1.width = 0; _m_tmpRect1.height = 0;
      _m_tmpRect1.x = _MAINPLAYERSTATUSPOS.x+30; _m_tmpRect1.y = _MAINPLAYERSTATUSPOS.y+4;
      _s_oFont.PutString(_m_tmpRect1, false, oPlayer.m_iCurLap.toString()+"/"+m_iNumLapsToRace.toString());

      double dSec = _m_dTotalTime[i_iActivePlayer]/1000;
      _m_tmpRect1.y = _MAINPLAYERSTATUSPOS.y+25;
      _s_oFont.PutString(_m_tmpRect1, false, dSec.toStringAsFixed(2));
    } else {
      if(m_oMap.MapType()==2) { //dogfight
        _m_tmpRect1.x = 0; _m_tmpRect1.y = 22;
        _m_tmpRect1.width = 112; _m_tmpRect1.height = 20;
        _s_oGraph.DrawImage2D(_m_oCargoFuel, _m_tmpRect1, _MAINPLAYERSTATUSPOS.x, _MAINPLAYERSTATUSPOS.y+22);
      } else {
        _s_oGraph.DrawImage2D(_m_oCargoFuel, null, _MAINPLAYERSTATUSPOS.x, _MAINPLAYERSTATUSPOS.y);
        //draw cargostatus
        Vector4 oCol = ((oPlayer.CargoNumInHold()>=MAXSPACEINHOLDUNITS) ||
          (oPlayer.CargoWeightInHold()>=MAXSPACEINHOLDWEIGHT)) ? _MAINPLAYERSTATUSCOLOR2 : _MAINPLAYERSTATUSCOLOR1;
        double dPercentUsed = oPlayer.CargoWeightInHold() / MAXSPACEINHOLDWEIGHT;
        int iWidth = (110*dPercentUsed).toInt();
        if(iWidth>0) {
          _m_tmpRect1.x = _MAINPLAYERSTATUSPOS.x+1; _m_tmpRect1.y = _MAINPLAYERSTATUSPOS.y+1;
          _m_tmpRect1.width = iWidth; _m_tmpRect1.height = 18;
          _s_oGraph.DrawRectangle2D(_m_tmpRect1, oCol);
        }
        //draw fuelstatus
        oCol = _MAINPLAYERSTATUSCOLOR1;
        dPercentUsed = oPlayer.FuelPercentLeft();
        iWidth = (110*dPercentUsed).toInt();
        if(iWidth>0) {
          _m_tmpRect1.x = _MAINPLAYERSTATUSPOS.x+1; _m_tmpRect1.y = _MAINPLAYERSTATUSPOS.y+23;
          _m_tmpRect1.width = iWidth; _m_tmpRect1.height = 18;
          _s_oGraph.DrawRectangle2D(_m_tmpRect1, oCol);
        }
      }
      //draw num lifes
      int i, iNumShips = oPlayer.GetNumLives();
      if(iNumShips>0) {
        _m_tmpRect2.x = 0; _m_tmpRect2.y = 0;
        _m_tmpRect2.width = 48; _m_tmpRect2.height = 48;
        int y = (_MAINPLAYERSTATUSPOS.y-24)+(m_oMap.MapType()==2 ? 22:0);
        for(i=0; i<iNumShips; i++) {
          int x = _MAINPLAYERSTATUSPOS.x+i*12;
          _m_tmpRect1.x = x; _m_tmpRect1.y = y;
          _m_tmpRect1.width = 16; _m_tmpRect1.height = 16;
          _s_oGraph.DrawImage2D_Blend2(s_oShipImg, _m_tmpRect2, _m_tmpRect1, _STATUSCOLOR[i_iActivePlayer]);
        }
      }
    }
  }

}
