
part of web_replay2;


class S_NetMsg1
{
  //MSG
  static const int N_MSG1_MOVEMENT  = 0x01;
  static const int N_MSG1_KEYCHANGE = 0x02;
  static const int N_MSG1_NEWBULLET = 0x04;
  static const int N_MSG1_KILLED    = 0x08;
  static const int N_MSG1_LANDED    = 0x10;
  static const int N_MSG1_SCORE     = 0x20;
  static const int N_MSG1_LAPINFO   = 0x40;

  //KEYSTATE
  static const int GF_KEY_ACCELERATE = 0x01;
  static const int GF_KEY_LEFT  = 0x02;
  static const int GF_KEY_RIGHT = 0x04;
  static const int GF_KEY_DOWN  = 0x08;

  int iMsg;
  int iSenderId;       //player id (or -1 for server)

  //N_MSG1_MOVEMENT, sent every time for movable objects
  double fPosX, fPosY;
  double fVelX, fVelY;
  double fAcceleration;
  double fDirection;

  double fGravityY;
  int   iCargoInHold;
  bool bCanCollide;

  //N_MSG1_KEYCHANGE, sent if changed (for correction)
  int iKeyFlag;

  //N_MSG1_NEWBULLET, new bullet (is sent if a bullet has been fired)
  //N_MSG1_KILLED, remove bullet (is sent if a bullet has collided with the player)
  int iNumBullets;
  int iBulletUniqeValBase; //the uniqe value that identifies this bullet (and the base if iNumBullets>1)
  //bullet direction is same as fDirection, velocity is same+BULLET_BASESPEED (use cos,sin(realdir))

  //N_MSG1_KILLED, player hit (computerenemy or human player)
  int iReason_Hits_Door;
  int iCauseID;

  //N_MSG1_SCORE
  int iScore;
  //N_MSG1_LAPINFO
  int iLap;
  int iCP;
  double fBestLapTime;
}

class S_NetMsg2
{
  static const int N_MSG2_NUMKILLS = 0x10;
  static const int N_MSG2_CARGO_R = 0x21;
  static const int N_MSG2_CARGORESPAWN = 0x23;
  static const int N_MSG2_GAMEOVER = 0x0E;

  int iType; //the msg (one of the above)

  int iPlayerId; //tag "id"
  int iGameId;   //tag "gid"

  int iInt1;
  int iInt2;
  int iInt3;
  String szLevelName = "";
  String szGameName = "";
  String szPlayerName = "";
  int iOptions;
  int iNumAI;
}

