// C_Resource

#ifndef _RESOURCE_H
#define _RESOURCE_H

#include "common.h"

class C_Resource
{
public:
	C_Resource();
	~C_Resource();

	void SetMode(bool i_bReading); //default reading (resets filenames)
	bool SetFilename(const char* i_szFilename, const char* i_szResname = NULL); //resname valid when reading (mode should be set first)

	bool   Read(void *i_pData, uint32_t i_iLength); //length==0xffffffff means entire resource
	void   Seek(uint32_t i_iPos, int i_iMode);
	uint32_t GetSize() {return m_iFileSize;};

	bool Write(void *i_pData, uint32_t i_iLength);

	//functions to find files in a directory
	static void *FileSearchOpen(char *i_szPath, char *i_szWild);
	static bool FileSearchNext(void *i_pHandle, char *o_szFilename, int i_iStringSize);
	static void FileSearchClose(void *i_pHandle);

	static void CreateDir(char *o_szDirname);

private:
	void Reset();
	bool     m_bReading;
	uint32_t m_iFileSize;
	uint32_t m_iFileStart;
	FILE     *m_pFileHandle;
};

#endif
