// C_Global

#ifndef _GLOBAL_H_
#define _GLOBAL_H_

#include "common.h"

class C_Global
{
public:
	static void Init(char *i_szDataFile, char *i_szUserDirName);

	static char* PathCombine(char *i_szFile, char *i_szPath);

	//Init() must run before the paths are changed to work
	static char szCurrentPath[MAX_PATH];
	static char szUserPath[MAX_PATH];
	static char szExePath[MAX_PATH];
	static char szDataPath[MAX_PATH];
	static char szResourceFile[MAX_PATH];

	//helper functions
	static char *GetNextLineAndCommand(FILE *i_pFile, char *o_szLine, char *o_szCommand);
	static bool GetNextLineAndCommand(char *i_szSrc, char *o_szLine, char *o_szCommand, int *io_iNextLineIndex);
	static bool GetWithin(char *i_szString, char i_cCh);
	static char *GetPositionAfter(char *i_szString, char i_cCh, int i_iIndex);

	//os gui
	static bool OpenDialog(char *o_szFile, int i_iSize, char *i_szInitialPath, char *i_szzFilter, char *i_szzFilterDescription);
	static bool GetClipboardBuffer(char *o_szText, int i_iSize);

	static bool OpenBrowser(char *i_szURL);
	
private:
	static bool FindDataPath(char *i_szDataFile);
	static void FixPath(char *i_szPath);

	static char szTemp[MAX_PATH];
};

#endif
