// C_Object (for mapeditor)

#ifndef OBJECT_H
#define OBJECT_H

#include "common.h"
#include "glgraph.h"
#include "image.h"

class C_Object
{
public: 
	C_Object();
	static void Init(S_Rect *i_pstScreenArea);

	int GetOwnerID() {return m_iOwnerID;};
	void SetOwnerID(int i_iOwnerID) {m_iOwnerID = i_iOwnerID;};
	void GetPos(int *o_iX, int *o_iY);
	void SetPos(int i_iX, int i_iY);
	bool GetSize(int *o_iSizeW, int *o_iSizeH);
	bool GetCenterPos(int *o_iCenterX, int *o_iCenterY);

	//transparent draw of the provided image onto screen if visible
	// (clipping preformed if partly visible)
	// i_Img      image
	// i_pstRect  object rectangle within i_Img, NULL = entire img
	// i_iX       x-cordinate of upper left corner of screen in the global space
	// i_iY       y-cordinate of upper left corner of screen in the global space
	// screenposition is (m_dPosX-i_x, m_dPosY-i_Y)
	void ODraw(C_Image *i_pclImg, S_Rect *i_pstRect, int i_iX, int i_iY, S_FColor *i_pstColor, bool i_bOutline);

protected:
	void ODrawInternal(C_Image *i_pclImg, S_Rect *i_pstRect, int i_iX, int i_iY);

	double m_dPosX;           //object global position in x-direction
	double m_dPosY;           //object global position in y-direction
	double m_dDirection;      //object direction in degrees

	int    m_iDirStep;        //number of degrees between each step (10=default)
	int    m_iRealDir;        //m_dDirection/m_iDirStep (the direction that the object can have)

	int    m_iOwnerID;

	static S_Rect s_stScreenArea; //screen area 
	C_GraphWrapperGL *m_pclGraph; //graphics interface

	S_Rect *m_pstImageRect;
	C_Image *m_pclImage;
};

#endif
