// C_MapBuilder

#ifndef MAPBUILDER_H
#define MAPBUILDER_H

#include <vector>

#include "common.h"
#include "image.h"
#include "e_tilemap.h"

class C_MapBuilder
{
public:
	C_MapBuilder(char *i_szSavePath);
	~C_MapBuilder();

	C_Map *MakeMapFromMask(char *i_szMaskFile);
	bool GetHeader(S_MapHeader *o_stHeader);
private:
	void InitPossibleList();
	bool LoadTileset();

	double GetTileMatchScore(C_Map *i_pclMap, int x, int y, int i_iTileNum, int i_iChekNeighbours);

	char      m_szSavePath[MAX_PATH];
	S_MapHeader m_stHeader;
	bool      m_bHeaderValid;

	//tileset
	S_Rect    *m_pstTileRects;
	C_Image   *m_pclTilesImg;
	int       m_iTileSize;
	int       m_iNumTiles;
	uint16_t  *m_pTileData;
	int       m_iTileLineWidth;
	std::vector<int> m_clPossibleList; //basic possible list

	//mask
	C_Image   *m_pclMaskImg;
	uint16_t  *m_pMaskData;
	int       m_iMaskLineWidth;
};

#endif
