// C_Grid

//class to represent the map for the AI

#pragma once

template <class _GridType>
class C_Grid
{
public:
	C_Grid() { bInited = false; };
	C_Grid(int i_iWidth, int i_iHeight) {
		iWidth = i_iWidth;
		iHeight = i_iHeight;
		AllocGridMem();
	}
	C_Grid(C_Grid *i_pclGrid) {
		iWidth = i_pclGrid->iWidth;
		iHeight = i_pclGrid->iHeight;
		AllocGridMem();
		for(int y=0; y<iHeight; y++) memcpy(aaGrid[y], i_pclGrid->aaGrid[y], iWidth*sizeof(_GridType));
	}
	~C_Grid() {
		if(!bInited) return;
		for(int y=0; y<iHeight; y++) delete[] aaGrid[y];
		delete[] aaGrid;
	}
	bool IsValid(int i_iX, int i_iY) {
		//checks if the given pos is within the map
		return ((i_iX < iWidth) && (i_iY < iHeight)
			&& (i_iX >= 0) && (i_iY >= 0));
	}

	_GridType& operator() (int x, int y) { 
		return aaGrid[y][x];
	}

	int  iWidth, iHeight;
	_GridType   **aaGrid;
private:
	void AllocGridMem() {
		aaGrid = new _GridType*[iHeight];
		for(int y=0; y<iHeight; y++) aaGrid[y] = new _GridType[iWidth];
		bInited = true;
	}

	bool bInited;
};

/*template <class _GridType>
class C_Grid <_GridType *>
{
public:
	C_Grid(int i_iWidth, int i_iHeight) {
		iWidth = i_iWidth;
		iHeight = i_iHeight;
		AllocGridMem();
	}

	~C_Grid() {
		for(int y=0; y<iHeight; y++)
		{
			for (int x = 0; x < iWidth; ++x)
			{
				if (aaGrid[y][x])
				{
					delete aaGrid[y][x];
				}
			}
			delete[] aaGrid[y];
		}
		delete[] aaGrid;
	}

	bool IsValid(int i_iX, int i_iY) {
		//checks if the given pos is within the map
		return ((i_iX < iWidth) && (i_iY < iHeight)
			&& (i_iX >= 0) && (i_iY >= 0));
	}

private:
	_GridType   ***aaGrid;
	int  iWidth, iHeight;

	_GridType* operator() (int x, int y) { 
		if (IsValid(x, y))
		{
			return aaGrid[x][y];
		}
		return NULL;
	}

	void AllocGridMem() {
		aaGrid = new _GridType**[iHeight];
		for(int y=0; y<iHeight; y++) 
		{
			aaGrid[y] = new _GridType*[iWidth];
			memset(aaGrid[y], 0, sizeof(_GridType*) * iWidth);
		}
	}
};
*/