#pragma once

#include "AIWorkerThread.h"

#include "FineGrainedPathFinder.h"

class SetUpPathfinderTask : public AIWorkerTask
{
public:
	SetUpPathfinderTask(FineGrainedPathFinder& pathFinder) : _pathFinder(pathFinder) {}
	void execute();
	void stop() {}

private:
	FineGrainedPathFinder& _pathFinder;
};

class FindPathTask : public AIWorkerTask
{
public:
	FindPathTask(FineGrainedPathFinder& pathFinder, S_ShipInfo source, POINT destination, ShipMoveVector& moves) : 
	  _pathFinder(pathFinder), _moves(moves), _source(source), _destination(destination) {}
	void execute();
	void stop() { _pathFinder.stop(); }

private:
	FineGrainedPathFinder& _pathFinder;
	ShipMoveVector& _moves;
	ShipMoveVector _tempMoves;
	S_ShipInfo _source;
	POINT _destination;
};
