#pragma once

#include "player.h"
#include "GameAI.h"

#include "FineGrainedPathFinder.h"

class StandardRaceAI :
	public C_RaceMapAI
{
public:
	StandardRaceAI(const S_StaticShipInfo& staticShipInfo);
	
	virtual ~StandardRaceAI();

	virtual void getOutput(const S_ShipInfo& shipInfo, S_AIOutput& output);
	virtual void setUp();
	
	virtual void setCurrentCheckpoint(const C_CheckPoint* pCheckpt);

private:
	bool pathDeviationExceeded() const;
	S_ExtendedAIOutput* getClosestState();

	ShipMoveVector _moves;
	FineGrainedPathFinder* _pathFinder;
	C_CheckPoint* _checkpoint;
	AIWorkerTask* _initPathfinderTask;
	AIWorkerTask* _findPathTask;
};
