// C_Bullet, C_BulletList

#ifndef BULLET_H
#define BULLET_H

#include "common.h"
#include "tilemap.h"
#include "glgraph.h"
#include "image.h"
#include "object.h"
#include "timer.h"
#include <vector>

#define BULLETLIFETIME  8000 //milliseconds


struct S_BulletInfo
{
	double dPosX, dPosY;
	double dVelX, dVelY;
	double dDirection;
};

class C_Bullet :public C_Object
{
public: 
	C_Bullet(C_Map *i_pclMap, S_BulletInfo *i_pstBulletInfo, int i_iOwnerID);
	~C_Bullet();
	bool Update(double i_dTime);
	void Draw();

	void SetUId(int i_iBulletUniqeVal) {m_iBulletUniqeVal = i_iBulletUniqeVal;};
	int GetUId() {return m_iBulletUniqeVal;};

private:
	static C_Image *s_pclBulletImg;
	static int s_iObjCount;

	double m_dTotAlive;
	int    m_iBulletUniqeVal;

	C_Map *m_pclMap;
};

typedef std::vector<C_Bullet*> C_BulletVector;

class C_BulletList
{
public: 
	C_BulletList();
	~C_BulletList();
	C_Bullet *GetNext(bool i_bReset);
	void Update(double i_dTime);
	void Draw();
	bool CheckCollision(C_Object *i_pclObject, int *o_iUID, bool i_bPlayerBulletsCollision);
	void Add(C_Bullet *i_pclBullet);
	void Remove(int i_iUID);

private:
	int m_iGetPos;
	C_BulletVector m_clBullets;
};

#endif
