// C_Environment

#ifndef ENVIRONMENT_H
#define ENVIRONMENT_H

#define DEFAULT_SHIPGRAVITYBASEX 0   //pixel/second 2
#define DEFAULT_SHIPGRAVITYBASEY 70  //pixel/second 2
#define DEFAULT_SHIPRESISTANCEX 0.68 //constant (velocity dependent)
#define DEFAULT_SHIPRESISTANCEY 0.43

#define DEFAULT_SHIPSTEARSPEED  235  //degree/second
#define DEFAULT_SHIPTHRUST      270  //pixel/second 2

#define BULLETBASEVEL           220  //pixel/second
#define BULLETFREETIME          3100 //millisec to be free from bullets when just come alive

#define OBJECT_HEADING_STEP     10   //degree

class C_Environment
{
public:
	static void InitializeDefault();
	static void Initialize(double i_dGravityX, double i_dGravityY, double i_dResistanceX, double i_dResistanceY, double i_dShipSteerSpeed, double i_dShipThrust);

	static double GetShipGravityBaseX() {return m_dShipGravityBaseX;};
	static double GetShipGravityBaseY() {return m_dShipGravityBaseY;};
	static double GetShipResistanceX() {return m_dShipResistanceX;};
	static double GetShipResistanceY() {return m_dShipResistanceY;};

	static double GetShipSteerSpeed() {return m_dShipSteerSpeed;};
	static double GetShipThrust() {return m_dShipThrust;};
private:
	static double m_dShipGravityBaseX;
	static double m_dShipGravityBaseY;
	static double m_dShipResistanceX;
	static double m_dShipResistanceY;
	static double m_dShipSteerSpeed;
	static double m_dShipThrust;
};

#endif
