// C_Chat

#ifndef _INGAMECHAT_H_
#define _INGAMECHAT_H_

#include "input.h"

#include "glgraph.h"
#include "font.h"

#define MAX_INGAME_CHATLENGTH 40
#define MAX_INGAME_CHATMSG    5

class C_Chat
{
public:
	C_Chat();
	~C_Chat();

	bool Update(double i_dTime); //returns true if a chat message has been entered
	void Draw(int x, int y);

	char *GetEnteredText() {return m_szEnteredText;}; //user must copy the buffer, it cannot be kept
	void AddChatString(char *i_szText);

	bool InEnteringTextMode() {return m_bEnteringText;};
private:
	void AddChar(char i_cC);
	int  GetInput();

	C_Control        *m_pclInput;
	C_GraphWrapperGL *m_pclGraph;


	C_Font    *m_pclFont;

	//enter text
	bool      m_bEnteringText;
	char      m_szEnteredText[MAX_INGAME_CHATLENGTH];

	//display text
	char      m_szChatText[MAX_INGAME_CHATMSG][MAX_INGAME_CHATLENGTH+16];
	double    m_dTimer[MAX_INGAME_CHATMSG];
};

#endif
