// C_NetMsg

#ifndef _NETMSG_H
#define _NETMSG_H

#include "socket_2.h"
#include "common.h"
#include "netmsgserver.h"

//simulate clients network lag to be able to see problems due to network speed while testing
//#define DEBUG_CLIENT_DELAY_MS 0 //delay milliseconds (0 should be used when not testing)
//^not implemented/used yet

#pragma pack(1)
struct S_NetPing
{
	uint8_t iMsg;      //'P' or 'R'
	int8_t  iPlayerId; //who the ping concerns
	int     iReplyPort;
};
#pragma pack()

class C_NetMsg
{
public:
	C_NetMsg(int i_iClientPortBase, int i_iClientPortSeekRange);
	~C_NetMsg();

	int GetRecvPort() {return m_iRecvPort;};
	C_Socket *GetRecvSocket() {return m_pclRecvSocket;};

	//UDP
	void SetIPList(int i_iIndex, int i_iIPNum, int i_iPort);
	//must be called after C_NetMsg() in UDP mode before use of object

	//TCP
	void SetServerComm(C_NetMsgServer *i_pclServerComm);

	void Reset();

	void AddMsg1(S_NetMsg1 *i_pstMsg1); //to be used in TCP mode
	void SendMsg1(S_NetMsg1 *i_pstMsg1);
	bool GetMsg1(int i_iId, S_NetMsg1 *o_pstMsg1);

private:
	C_NetMsgServer *m_pclServerComm;
	void Init(int i_iClientPortBase, int i_iClientPortSeekRange); //used by constructors

	void DrainSocket(C_Socket *i_pclSocket);
	void Recieve();

	C_Socket *m_pclRecvSocket; //recv data from all
	int m_iRecvPort;
	C_Socket *m_pclUDPSocket[8]; //send data

	int m_aiNumInList[256];
	C_Msg1List *m_pclMsg1List;
};

#endif
