// C_ShowHiscore

//class to draw the server hiscore list for a level

#include <stdio.h> //sprintf
#include "showhiscore.h"
#include "global.h"

POINT PLACE[10] = {
	{0,  0},{0,  16},{0,  32},{0,  48},{0,  64},
	{225,0},{225,16},{225,32},{225,48},{225,64}
};

C_ShowHiscore::C_ShowHiscore()
{
	m_pclGraph = C_GraphWrapperGL::GetGraphWrapperObject();

	m_pclFont = new C_Font(_RGBA8888);
	m_pclFont->Load((char*)"arial14", C_Global::szResourceFile);

	m_iNumValid = 0;
}

C_ShowHiscore::~C_ShowHiscore()
{
	delete m_pclFont;
}

//sets all data
void C_ShowHiscore::SetHiscoreList(S_HiScore *i_pstList)
{
	memcpy(&m_stList, i_pstList, sizeof(S_HiScore));
	m_iNumValid = m_stList.iNumInList;
}

//draw all data
// - the position is based on the position of DLG2
//   all depends of the screen area (given in the parameters)
void C_ShowHiscore::Draw(int i_iWidth, int i_iHeight)
{
	int i, iWidth, iPrecision;

	int iBaseY = i_iHeight/2-396/2 +12 +396+4; //4 below dialog
	int iBaseX = (i_iWidth-520)/2;

	//draw levelname
	if(m_iNumValid) {
		m_pclFont->GetTextSize(m_stList.szLevelName, &iWidth);
		m_pclFont->Print((i_iWidth-iWidth)/2, iBaseY+16*5+2, m_stList.szLevelName);
	}

	//draw each entry
	for(i=0; i<m_iNumValid; i++) {
		iPrecision = m_stList.iScore[i]<-100000 ? 0 :2;
		m_pclFont->Print(iBaseX+PLACE[i].x,     iBaseY+PLACE[i].y, "%d.", i+1);
		m_pclFont->Print(iBaseX+PLACE[i].x+24,  iBaseY+PLACE[i].y, m_stList.szName[i]);
		m_pclFont->Print(iBaseX+PLACE[i].x+140, iBaseY+PLACE[i].y, "%.*f", iPrecision, m_stList.iScore[i]/1000.0f);
	}
}
