// C_ImageDiskOP

#ifndef _IMAGEDISKOP_H
#define _IMAGEDISKOP_H

#include "image.h"

//fileformats
#define _ERROR  0
#define _GIF87  3
#define _TARGA  4
#define _JPEG   5
#define _BMP    6

class C_ImageDiskOP
{
public:
	C_ImageDiskOP();
	/* constructor that does nothing special */
	~C_ImageDiskOP();
	/* destructor; clean up */
	C_ImageDiskOP(char *i_szFilename, char *i_szRsname, C_Image **o_ppclDstImg);
	/* a simple way of creating the obj, load one image and deleting the obj.
	the obj will delete itself after its done loading. dst is filled with a
	new image of the same type as the image on file (you might need to convert it
	before use) or NULL if fail */

	bool Load(char *i_szFilename, char *i_szRsname, C_Image **o_ppclDstImg);
	/* filename is the name(and path) of the file, or file within a resource.
	resname should be name(and path) of a resource file or NULL.
	dst is filled with a new image of the same type as the image on file
	(you might need to convert it before use) or NULL if fail */

	bool Save(char *i_szFilename, C_Image *i_pclSrcImg);
	/* saves i_pclSrcImg to the file i_szFilename (with path).
	the extension of i_szFilename can be: (.tga) */
private:
	int DetectFormat(char *i_szFilename);
	/* decides what fileformat, based on the extension */
};

#endif
