// C_Manager

#ifndef _CMANAGER_H
#define _CMANAGER_H

#include "../galaxyv2/netmsgserver.h"
#include "s_game.h"
#include "hiscorelist.h"
#include "logger.h"

#define MAX_GAMES 50

class C_Manager
{
public:
	C_Manager();
	~C_Manager();

	void NewPlayer(C_Socket *i_pclSocket);

	void ProcessNetMsg(); //run to receive and process network msg
	void Update();        //run 1/sec typ, to see if its gameover for any game

	void ResetCurUnnamedPlayer();
	char *GetNextUnnamedPlayerIPString();

	void ResetCurGame();
	C_Game *GetNextGame();
	char *GetGameString(C_Game *i_pclGame);
	char *GetPlayerString(C_Game *i_pclGame);
private:
	//in game setup
	void AddPlayerToGame(C_Player *i_pclPlayer, char *i_szGameName);
	void CreateNewGame(C_Player *i_pclPlayer, char *i_szGameName);
	void SendGameStatus(C_Game *i_pclGame);
	void SendRemoveGame(C_Game *i_pclGame);

	//in game
	void SendGameOver();
	void HandleScore(C_Game *i_pclGame, C_Player *i_pclPlayer, int i_iScore);

	//send info
	void SendToPlayerList(S_NetMsg2 *i_pstMsg);
	void SendHiScore(C_Game *i_pclGame, C_Player *i_pclPlayer);
	//search game
	C_Game *SearchGame(char* i_szGameName);

	//list of games
	C_GameList *m_pclGameList;
	int m_iGameIdCounter;
	//list of players not in any game yet
	C_PlayerList *m_pclPlayerList;

	char m_szTempString[300];
	int  m_iCurGame;
	int  m_iCurPlayer;

	C_Logger *m_pclLog;
};

#endif
