// C_Player

//class that keeps info for one player in a game on the server

#include <string.h>
#include "s_player.h"


C_Player::C_Player(C_Socket *i_pclSocket)
{
	m_pclSocket = i_pclSocket;
	m_pclNetMsg = new C_NetMsgServer(m_pclSocket);
	m_szName[0] = 0;
	m_iIndex = 0;

	m_bIsMaster = false;

	m_iNumLifes = -1;
	m_iNumKills = 0;
	m_iNumLaps  = 0;

	//get ip string
	struct in_addr stAddr;
	stAddr.s_addr = m_pclSocket->ConnectedToIP();
	strcpy(m_szIP, inet_ntoa(stAddr));
}

C_Player::~C_Player()
{
	delete m_pclNetMsg;
	//m_pclSocket should not be deleted
}

void C_Player::SetName(char *i_szPlayerName)
{
	strcpy(m_szName, i_szPlayerName);
}

char *C_Player::GetName()
{
	return m_szName;
}

bool C_Player::CompareName(char *i_szName)
{
	int iCheck = strcmp(i_szName, m_szName);

	return (iCheck==0);
}

char *C_Player::GetIPString()
{
	return m_szIP;
}

C_Socket *C_Player::GetSocket()
{
	return m_pclSocket;
}

bool C_Player::CompareSocket(C_Socket *i_pclSocket)
{
	return (i_pclSocket == m_pclSocket);
}

C_NetMsgServer *C_Player::GetNetMsg()
{
	return m_pclNetMsg;
}
